
-------- SIMTEL20 Ada Software Repository Prologue ------------
--                                                           -*
-- Unit name    : CAIS
-- Version      : 860307
-- Author       : Mitre Corp.
--              : Rebecca Bowerman	Helen Gill
--              : Chuck Howell		Robbie Hutchison
--              : Mike McClimens
-- DDN Address  : cig-info at mitre
-- Copyright    :
-- Date created : 07 MAR 86
-- Release date : 07 MAR 86
-- Last update  : 07 MAR 86
-- Machine/System Compiled/Run on : Vax 8600
--               :                   UNIX (Berkeley 4.2 based)
--		:			Ultrix 1.2 on VAX 8600
--		:			Sun UNIX 4.2 Release 2.0 on Sun2s
--              :                    Verdix Ada Development Sys
--                                                           -*
---------------------------------------------------------------
--                                                           -*
-- Keywords     :  Tool Interfaces, Portability, Stoneman,
--       :          Operating System Calls, Host-Dependencies,
--       :          MIL-STD-CAIS, APSE, Programming Support Environment
----------------:
--
-- Abstract     :  
--         This CAIS package provides a robust subset of the inter-
--    faces defined in the proposed Military Standard Common Apse
--    Interface Set(CAIS).  The goal of MIL-STD-CAIS is to promote
--    tool portability by providing a standardized set of calls for
--    operating system services.  It is also hoped that definition
--    of a generalized node model will increase the interoperability
--    of tool sets.
--         
--         This subset includes:
--             5.1.1,2,3,5 -- Node_Definitions, Node_Management,
--                            Attributes, and Structural_Nodes
--             5.3.1,1-4,10-- Io_Definitions ,Direct_Io, Sequential_Io,
--                            Text_Io, and File_Import_Export (also a 
--                            few procedures from Scroll_Terminal)
--             5.4.1-20,21 -- List_Utilities, Identifier_Items, and
--                            String_Items
--    The interfaces not included are Access_Control, Process_Control,
--    Io_Control, the Io device packages, Float_Item, and Integer_Item.
--
--         It is intended that this CAIS subset be used to investigate
--    the extent to which CAIS supports the needs of software 
--    development tools.  Only by rehosting tools and their data to
--    CAIS can the viability of CAIS be determined.
----------------:  
--                                                           -*
------------------ Revision history ---------------------------
--                                                           -*
-- DATE      VERSION AUTHOR        HISTORY
-- 03/07/85  860307  Mitre Corp    Initial Release
--                                                           -*
------------------ Distribution and Copyright -----------------
--                                                           -*
-- This prologue must be included in all copies of this software.
--
-- This software is released to the Public Domain (note:
--   software released to the Public Domain is not subject
--   to copyright protection).
--
-- Restrictions on use or distribution:  Although there are
--      no current plans to provide maintenance for this CAIS,
--      further modifications are planned. We would appreciate
--      your reporting problems and experiences to:
--              
--                cig-info at mitre    (net address)
--
--      or call at:
--
--                (703)  883-7858
--                                                           -*
------------------ Disclaimer ---------------------------------
--                                                           -*
-- This software and its documentation are provided "AS IS" and
-- without any expressed or implied warranties whatsoever.
-- No warranties as to performance, merchantability, or fitness
-- for a particular purpose exist.
--
-- Because of the diversity of conditions and hardware under
-- which this software may be used, no warranty of fitness for
-- a particular purpose is offered.  The user is advised to
-- test the software thoroughly before relying on it.  The user
-- must assume the entire risk and liability of using this
-- software.
--
-- In no event shall any person or organization of people be
-- held responsible for any direct, indirect, consequential
-- or inconsequential damages or lost profits.
--                                                           -*
-------------------END-PROLOGUE--------------------------------

