

-------- SIMTEL20 Ada Software Repository Prologue ------------
--                                                           -*
-- Unit name    : CAISTEST
-- Version      : 860307
-- Author       : Mitre Corp.
--              : Rebecca Bowerman	Helen Gill
--              : Chuck Howell		Robbie Hutchison
--              : Mike McClimens
-- DDN Address  : cig-info at mitre
-- Copyright    :
-- Date created : 07 MAR 86
-- Release date : 07 MAR 86
-- Last update  : 07 MAR 86
-- Machine/System Compiled/Run on : Vax 8600
--               :                   UNIX
--               :                   Verdix Ada Development Sys
--                                                           -*
---------------------------------------------------------------
--                                                           -*
-- Keywords     :  Tool Interfaces, Portability, Stoneman,
--     :            Operating System Calls, Host-Dependencies,
--     :            MIL-STD-CAIS, APSE, Programming Support Environment,
--     :            Regression Tests
----------------:
--
-- Abstract     :  
--         This set of tests exercises a wide range of the
-- implemented CAIS interfaces.  In general the results of the
-- tests are self-documenting.  However they are programmer-
-- developed tests and are not as rigorous as might be
-- expected for acceptance testing.  They also vary in style.
-- In some instances dependencies upon the state of the node
-- model remain in these tests and thus may require the
-- existence (or non-existence) of nodes and/or attributes.
--
-- The tests are:
--   attribute_ex.a               => Test Exceptions on Attribute Com
--   cais_commandos.a             => Set of Interactive CAIS Commands
--   copytree_test.a              => Tests Copy_Tree(+Node), Rename
--   existree_ex.a                => Same as Nodetree_ex sans Creates
--   io_ex_create_test.a          => Test Exceptions on Text_Io.Create
--   io_ex_open_test.a            => Test Exceptions on Text_Io.Open
--   io_ex_delete_test.a          => Test Exceptions on Text_Io.Delete
--   list_test_02_12.a            => Tests List_Utilities 5.4.2 - 12
--   list_test_13_ss.a            => Tests List_Utilities 5.4.13 - 23
--   list_tstex.a                 => Tests Exceptions on List_Utilities
--   listutst.a                   => Five Quick List_Utilities Tests
--   list_utilities_tests-body.a        => Part of Above
--   list_utilities_tests-spec.a        => Part of Above
--   natt_tst_all.a               => Test Node Attribute Commands
--   natt_tst_it.a                => Test Node Attribute Iterators
--   new_user.a                   => Adds New_Users
--   node_mgnt.a                  => Tests some of Node-Management
--   node_management_tests-body.a       => Part of Above
--   node_management_tests-body.a       => Part of Above
--   nodetree_ex.a                => Tests some Node_Management Excep.
--   nodetree_cleanup.a                 => Deletes Nodes from Above
--   patt_tst_all.a               => Test Path Attribute Commands
--   patt_tst_it.a                => Test Path Attribute Iterators
--   struct_nodes.a               => Main for Structural_Nodes test
--   structural_nodes_tests-body.a      => Part of Above
--   structural_nodes_tests-spec.a      => Part of Above
--   test_internals.a             => Test Window into Cais Insides
--   test_node_iterate.a          => Tests Node Iterate
--   text_test.a                  => Tests some of Text_Io
--   text_io_tests-body.a               => Part of Above
--   text_io_tests-spec.a               => Part of Above
--
--         The tests should be run when the CAIS is installed
-- and users have been added.  They can also be run as
-- regression tests, if the CAIS code is modified.  They may
-- be helpful as supplementary (though rudimentary) examples
-- to MIL-STD-CAIS
----------------:  
--                                                           -*
------------------ Revision history ---------------------------
--                                                           -*
-- DATE      VERSION AUTHOR        HISTORY
-- 03/07/85  860307  Mitre Corp    Initial Release
--                                                           -*
------------------ Distribution and Copyright -----------------
--                                                           -*
-- This prologue must be included in all copies of this software.
--
-- This software is released to the Public Domain (note:
--   software released to the Public Domain is not subject
--   to copyright protection).
--
-- Restrictions on use or distribution:  Although there are
--      no current plans to provide maintenance for this set of
--      CAIS tests, further modifications are planned. We would
--      appreciate your reporting problems and experiences to:
--              
--                cig-info at mitre    (net address)
--
--      or call at:
--
--                (703)  883-7858
--                                                           -*
------------------ Disclaimer ---------------------------------
--                                                           -*
-- This software and its documentation are provided "AS IS" and
-- without any expressed or implied warranties whatsoever.
-- No warranties as to performance, merchantability, or fitness
-- for a particular purpose exist.
--
-- Because of the diversity of conditions and hardware under
-- which this software may be used, no warranty of fitness for
-- a particular purpose is offered.  The user is advised to
-- test the software thoroughly before relying on it.  The user
-- must assume the entire risk and liability of using this
-- software.
--
-- In no event shall any person or organization of people be
-- held responsible for any direct, indirect, consequential
-- or inconsequential damages or lost profits.
--                                                           -*
-------------------END-PROLOGUE--------------------------------

