-------- SIMTEL20 Ada Software Repository Prologue ------------
--                                                           -*
-- Unit name    : EDITOR (ALED - Ada Line Editor)
-- Version      : 3.1
-- Author       : Richard Conn
--              : Texas Instruments
--              : PO Box 801, MS 8007
--              : McKinney, TX  75069
-- DDN Address  : RCONN at SIMTEL20
-- Copyright    : (c) 1984, 1985 Richard Conn
-- Date created :  9 Nov 84
-- Release date :  5 Dec 84
-- Last update  :  13 Feb 86
-- Machine/System Compiled/Run on : VAX 8600 ULTRIX, Sun2 UNIX 4.2
--                                                           -*
---------------------------------------------------------------
--                                                           -*
-- Keywords     :  EDITOR
----------------:  LINE-ORIENTED EDITOR
----------------:  INPUT-LINE EDITOR
--
-- Abstract     :  ALED - Ada Line Editor
----------------:  A Line-Oriented File Editor Written in Ada
----------------:  by Richard Conn
----------------:  
----------------:  ALED is designed to edit text files.  Upon invocation,
----------------:  ALED prompts the user for a file name.  If the file
----------------:  exists, its contents (lines) are read in and prepared
----------------:  for editing; if the file does not exist, the file is
----------------:  created and the empty buffer is prepared for editing.
----------------:  ALED is an interactive editor, accepting single-char
----------------:  commands, filling in a command prompt (for more info
----------------:  as needed), and performing its functions in real-time
----------------:  while the user watches.  The functions provided include
----------------:  (but are not limited to) the following:
----------------:  
----------------:     * List Lines
----------------:     * Insert a Group of Lines into the Edit Buffer
----------------:     * Delete Lines
----------------:     * String Search and String Substitution
----------------:     * Movement Within the Edit Buffer
----------------:     * Reading in a File After a Specified Line
----------------:     * Writing out a Range of Lines to a File
----------------:     * Built-in, online Documentation (Summary)
----------------:  
----------------:  ALED's design includes an input line editor, which allows
----------------:  the user to edit text as he types it.  I was surprised
----------------:  NOT to find such a basic function available in TEXT_IO.
----------------:  Did I miss something?
----------------:  
----------------:  ALED is divided into the following files.  The order
----------------:  in which they are listed is the compilation order.
----------------:  
----------------:  SIMTEL20      Ada Package/Procedure  Comments
----------------:
----------------:  LIST.ADA      generic_list           Components library
----------------:                                       of linked-list routines
----------------:  
----------------:  ED-SPT.ADA    edit_support           Visible section
----------------:                                       of editor support
----------------:                                       package (which contains
----------------:                                       a few basic routines,
----------------:                                       such as the input line
----------------:                                       editor)
----------------:  
----------------:  ED-SPTB.ADA   edit_support           Body of editor support
----------------:                                       package
----------------:  
----------------:  ED-WRK.ADA    edit_worker            Visible seciton of
----------------:                                       workhorse routines
----------------:                                       for the editor;
----------------:                                       all major editor
----------------:                                       functions and their
----------------:                                       related support
----------------:                                       routines are here
----------------:                                       (such as list lines)
----------------:  
----------------:  ED-WRKB.ADA   edit_worker            Body of editor
----------------:                                       workhorse routines
----------------:  
----------------:  ED.ADA        editor                 Mainline of ALED
----------------:  
----------------:  
--                                                           -*
------------------ Revision history ---------------------------
--                                                           -*
-- DATE         VERSION	AUTHOR                  HISTORY
-- 12/5/84        1.0   Richard Conn            Initial Release
-- 1/21/85        2.0   Richard Conn            Production version
-- 2/15/85        2.1   Richard Conn            Minor bug fix
-- 8/21/85        3.0   Chuck Howell            Port to CAIS
-- 2/13/86        3.1   Chuck Howell            Change CAIS Version
--    NB: changes for the CAIS port are indicated by one of the following 
--        on each affected line:
--        --!Rem   Comments, remarks
--        --!Add   Lines added to the code
--        --!Del   Lines deleted from the code
--        --!Cha   Lines changed in the code
--        (It is a bit subjective; when does a big change become
--         a delete and an add ?)
--                                                           -*
------------------ Distribution and Copyright -----------------
--                                                           -*
-- This prologue must be included in all copies of this software.
--
-- This software is copyright by the author.
--
-- This software is released to the Ada community.
-- This software is released to the Public Domain (note:
--   software released to the Public Domain is not subject
--   to copyright protection).
-- Restrictions on use or distribution:  NONE
--                                                           -*
------------------ Disclaimer ---------------------------------
--                                                           -*
-- This software and its documentation are provided "AS IS" and
-- without any expressed or implied warranties whatsoever.
-- No warranties as to performance, merchantability, or fitness
-- for a particular purpose exist.
--
-- Because of the diversity of conditions and hardware under
-- which this software may be used, no warranty of fitness for
-- a particular purpose is offered.  The user is advised to
-- test the software thoroughly before relying on it.  The user
-- must assume the entire risk and liability of using this
-- software.
--
-- In no event shall any person or organization of people be
-- held responsible for any direct, indirect, consequential
-- or inconsequential damages or lost profits.
--                                                           -*
-------------------END-PROLOGUE--------------------------------
