
-------- SIMTEL20 Ada Software Repository Prologue ------------
--
-- Unit name    : generic package date_package
-- Version      : 1.0
-- Authors      : David G. Gawron
--              : Dr. Mars J. Gralia
--              : The Johns Hopkins University
--              : Applied Physics Laboratory
--              : Johns Hopkins Road
--              : Laurel, Maryland  20707
-- DDN Address  : dgg@aplvax gralia@aplvax
-- Copyright    : (c) 1986 David G. Gawron, Dr. Mars J. Gralia
-- Date created :  October  1986
-- Release date :  November 1986
-- Last update  :  Gawron, October  1986
-- Machine/System Compiled/Run on : DEC VAX 11/750, DEC Ada v1.3
--
---------------------------------------------------------------
--
-- Keywords     :  Calendar, Date, Julian Date
--
-- Abstract     :  
--
--   This generic package provides arithmetic and logical operations
-- for dates.  It strongly parallels the required CALENDAR
-- package, but differs primarily in the range of dates handled.
-- Like CALENDAR, routines such as SPLIT, MONTH, DAY, and YEAR
-- are available.
--
--   The differences between this package and CALENDAR are reflected
-- in the range of dates, the inclusion of a DAY_NAME function,
-- and the ability to specify a date with a year and an annual
-- Julian day number *.  A day is the smallest unit of time in
-- this package.
--
--   An important feature is the ability to subtract dates over
-- the full range of years.  Thus, you can for example, calculate
-- the number of days between 10/15/1986 and 1/1/1988.  Another
-- important feature is the ability to add (or subtract) x number
-- of days from a date and obtain a date x days in the future
-- (or past).
--
--   The package fully accounts for leap years and validates all
-- dates given by a user.
--
--
-- * An annual Julian day number counts the days in a year.
--   For example, December 31 has an annual Julian day number of
--   365 for non-leap years and 366 for leap years.
--
------------------ Revision history ---------------------------
--
-- DATE         VERSION	AUTHOR                  HISTORY
-- 10/86        1.0     Gawron                  Initial release
--
------------------ Distribution and Copyright -----------------
--
-- This prologue must be included in all copies of this software.
--
-- This software is copyright by the author.
--
-- This software is released to the Ada community.
-- Restrictions on use or distribution:  NONE
--
------------------ Disclaimer ---------------------------------
--
-- This software and its documentation are provided "AS IS" and
-- without any expressed or implied warranties whatsoever.
-- No warranties as to performance, merchantability, or fitness
-- for a particular purpose exist.
--
-- Because of the diversity of conditions and hardware under
-- which this software may be used, no warranty of fitness for
-- a particular purpose is offered.  The user is advised to
-- test the software thoroughly before relying on it.  The user
-- must assume the entire risk and liability of using this
-- software.
--
-- In no event shall any person or organization of people be
-- held responsible for any direct, indirect, consequential
-- or inconsequential damages or lost profits.
--
-------------------END-PROLOGUE--------------------------------
