

-------- SIMTEL20 Ada Software Repository Prologue ------------
--
-- Unit name    : DIMENSIONAL_UNITS
-- Version      : 1.0
-- Author       : Do-While Jones
--              : 324 Traci Lane
--              : Ridgecrest, CA 93555
--              : (619) 375-4607
-- DDN Address  : 
-- Copyright    : (c) 
-- Date created :  
-- Release date : 1 May 1987
-- Last update  :  
-- Machine/System Compiled/Run on :
--  DEC Ada on VAX
--  APLEX (Telegen 2) on Gould 32/97 running MPX
--  Does not run on Alsys on AT because of a bug in Alsys.
--  (The DUTEST program will tell you if it works on your system.)
--
---------------------------------------------------------------
--
-- Keywords     : Dimensional Units
--
-- Abstract     :  
--   This package provides useful parent types for derived
--   dimensional units. That is, it makes it possible to
--   do this:
--      type Feet is new Integer_Unit;
--      type Radians is new Float_Unit;
--   Objects of type Feet can be added together, but can't be
--   multiplied together to get a result in feet.
--
--  See Dr. Dobb's Journal of Software Tools issue #127
--  (May 1987) page 50 for a complete description of how to
--  use this package.
--
--  Unfortunately Dr. Dobb failed to publish the package body and
--  the test routines.
--
--  The complete set of files consists of:
--    DUNITS.ADA (DIMENSIONAL_UNITS package specification)
--    DUNITB.ADA (DIMENSIONAL_UNITS package body)
--    DUEX.ADA   (procedure Speed_Gun example program)
--    DUTEST.ADA (Exhaustive test program with 3 subunits)
--    DUTEST1.ADA (subunit 1)
--    DUTEST2.ADA (subunit 2)
--    DUTEST3.ADA (subunit 3)
--
------------------ Revision history ---------------------------
--
-- DATE         VERSION	AUTHOR                  HISTORY
--
------------------ Distribution and Copyright -----------------
--
-- This prologue must be included in all copies of this software.
--
-- This software is released to the Public Domain (note:
--   software released to the Public Domain is not subject
--   to copyright protection).
-- Restrictions on use or distribution:  NONE
--
------------------ Disclaimer ---------------------------------
--
-- This software and its documentation are provided "AS IS" and
-- without any expressed or implied warranties whatsoever.
-- No warranties as to performance, merchantability, or fitness
-- for a particular purpose exist.
--
-- Because of the diversity of conditions and hardware under
-- which this software may be used, no warranty of fitness for
-- a particular purpose is offered.  The user is advised to
-- test the software thoroughly before relying on it.  The user
-- must assume the entire risk and liability of using this
-- software.
--
-- In no event shall any person or organization of people be
-- held responsible for any direct, indirect, consequential
-- or inconsequential damages or lost profits.
--
-------------------END-PROLOGUE--------------------------------
