-------- SIMTEL20 Ada Software Repository Prologue ------------
--                                                           -*
-- Unit name    : generic package File_Compare_Utilities
-- Version      : 2.0 (SUEP207)
-- Author       : Geoffrey O. Mendal
--              : Stanford University
--              : Computer Systems Laboratory
--              : Stanford, CA  94305
--              : (415) 723-1414 or 723-1175
-- DDN Address  : Mendal@Sierra.Stanford.Arpa
-- Copyright    : (c) 1985, 1986, 1987 Geoffrey O. Mendal
-- Date created : Sat 28 Dec 85
-- Release date : Sun 29 Dec 85
-- Last update  : MENDAL Sun 20 Sep 87
-- Machine/System Compiled/Run on : DG MV10000, ROLM ADE
--                                  VAX 11/780, DEC ACS
--                                  RATIONAL R1000
--                                  Sequent DYNIX, VADS
--                                  Sun/3 UNIX, VADS
-- Dependent Units : package TEXT_IO
--                   package CALENDAR
--                   package TOD_Utilities
--                                                           -*
---------------------------------------------------------------
--                                                           -*
-- Keywords     :  COMPARE
----------------:  FILE COMPARE
--
-- Abstract     :  This generic package contains routines to
----------------:  compare two ASCII files.  It produces as
----------------:  output a side-by-side listing of both files,
----------------:  showing their differences in a very readable
----------------:  format, and also produces an update deck which
----------------:  can be used to provide a mapping between the
----------------:  two files.  This update deck is meant to be
----------------:  input for a revision control package, called
----------------:  Context_Directed_Update_Utilities.
--                                                           -*
------------------ Revision history ---------------------------
--                                                           -*
-- DATE         VERSION	          AUTHOR     HISTORY
-- 12/29/85     1.0 (SAEC285)     Mendal     Initial Release
-- 01/24/86     1.1 (FRAN246)     Mendal     Bug fixes, enhancements
-- 04/19/86     1.2 (SAPR196)     Mendal     Enhancements
-- 09/20/87     2.0 (SUEP207)     Mendal     Major interface enhancements
--                                                           -*
------------------ Distribution and Copyright -----------------
--                                                           -*
-- This prologue must be included in all copies of this software.
--
-- This software is copyright by the author.
--
-- This software is released to the Ada community.
-- This software is released to the Public Domain (note:
--   software released to the Public Domain is not subject
--   to copyright protection).
-- Restrictions on use or distribution:  NONE
--                                                           -*
------------------ Disclaimer ---------------------------------
--                                                           -*
-- This software and its documentation are provided "AS IS" and
-- without any expressed or implied warranties whatsoever.
-- No warranties as to performance, merchantability, or fitness
-- for a particular purpose exist.
--
-- Because of the diversity of conditions and hardware under
-- which this software may be used, no warranty of fitness for
-- a particular purpose is offered.  The user is advised to
-- test the software thoroughly before relying on it.  The user
-- must assume the entire risk and liability of using this
-- software.
--
-- In no event shall any person or organization of people be
-- held responsible for any direct, indirect, consequential
-- or inconsequential damages or lost profits.
--                                                           -*
-------------------END-PROLOGUE--------------------------------
