


-------- SIMTEL20 Ada Software Repository Prologue ------------
--                                                           -*
-- Unit name    : IO_SUPPORT
-- Version      : 1.0
-- Author       : Richard Conn
--              : Texas Instruments, Ada Technology Branch
--              : PO Box 801, MS 8007
--              : McKinney, TX  75069
-- DDN Address  : RCONN at SIMTEL20
-- Copyright    : (c) 1985 Richard Conn
-- Date created : 15 Feb 85
-- Release date : 15 Feb 85
-- Last update  : 15 Feb 85
-- Machine/System Compiled/Run on : DG MV 10000, ROLM ADE
--                                                           -*
---------------------------------------------------------------
--                                                           -*
-- Keywords     :
----------------: Input Line Editor, I/O Support
--
-- Abstract     :
----------------: IO_SUPPORT is a companion package for SYSDEP,
-- a system dependencies package that provides console input and
-- console output without echo on the input and without control
-- character interpretation.  IO_SUPPORT, which employs SYSDEP,
-- provides an input line editor and interfaces to the routines
-- in SYSDEP which provide a greater degree of functionality than
-- SYSDEP itself provides.
--
--      For applications which are embedded and do not require
-- features of TEXT_IO other than simple character or string I/O,
-- IO_SUPPORT with SYSDEP offer an alternative to withing in the
-- entire TEXT_IO package.
--
--      The philosophy behind creating SYSDEP is to provide low-level
-- I/O routines which can be built upon to implement applications which
-- require raw I/O, such as communications servers and character-oriented
-- tools.  IO_SUPPORT goes one step further by providing a set of
-- commonly-used routines around SYSDEP, preventing the need for
-- constantly reinventing the basic wheel.
--                                                           -*
------------------ Revision history ---------------------------
--                                                           -*
-- DATE         VERSION AUTHOR                  HISTORY
-- 2/15/85      1.0     Richard Conn            Initial Release
--                                                           -*
------------------ Distribution and Copyright -----------------
--                                                           -*
-- This prologue must be included in all copies of this software.
--
-- This software is copyright by the author.
--
-- This software is released to the Ada community.
-- This software is released to the Public Domain (note:
--   software released to the Public Domain is not subject
--   to copyright protection).
-- Restrictions on use or distribution:  NONE
--                                                           -*
------------------ Disclaimer ---------------------------------
--                                                           -*
-- This software and its documentation are provided "AS IS" and
-- without any expressed or implied warranties whatsoever.
-- No warranties as to performance, merchantability, or fitness
-- for a particular purpose exist.
--
-- Because of the diversity of conditions and hardware under
-- which this software may be used, no warranty of fitness for
-- a particular purpose is offered.  The user is advised to
-- test the software thoroughly before relying on it.  The user
-- must assume the entire risk and liability of using this
-- software.
--
-- In no event shall any person or organization of people be
-- held responsible for any direct, indirect, consequential
-- or inconsequential damages or lost profits.
--                                                           -*
-------------------END-PROLOGUE--------------------------------
