-------- SIMTEL20 Ada Software Repository Prologue ------------
--                                                           -*
-- Unit name    : generic package NETWORK_IO
-- Version      : 2.0
-- Author       : Stanley R. Allen
--              : Lockheed Engineering Management Services Company
--              : Computer Systems Engineering Department  MS B08
--              : Houston, TX  77258
--              : (713) 333-6120
-- DDN Address  : SALLEN%LOCK.SPAN@Jpl-VLSI.ARPA
-- Copyright    : none
-- Date created : Fri 31 Jul 87
-- Release date : Mon 31 Aug 87
-- Last update  : Mon 31 Aug 87
-- Machine/System Compiled/Run on : VAX 11/785, VAX 8650
--                                                           -*
---------------------------------------------------------------
--                                                           -*
-- Keywords     :  NETWORK, COMMUNICATION
----------------:
--
-- Abstract     :  This package provides an Ada interface to a
----------------:  communication network.  The model of the network
----------------:  is one that allows tasks on separate nodes to
----------------:  pass messages (message-passing).  The package
----------------:  is designed to be similar to the standard
----------------:  package SEQUENTIAL_IO, with the same basic
----------------:  operations, applicable to networks.  The
----------------:  idea of SEQUENTIAL_IO (just as for the other
----------------:  predefined I/O packages) is machine independent
----------------:  logical operations defined in the spec, and
----------------:  machine dependencies hidden in the private
----------------:  parts and the bodies.  Currently NETWORK_IO
----------------:  allows any typed link to be created between
----------------:  two VAX DECnet nodes.
-- Dependent Units : package SYSTEM, STARLET, CONDITION_HANDLING,
--                   IO_EXCEPTIONS, TASKING_SERVICES.
--                                                           -*
------------------ Revision history ---------------------------
--                                                           -*
-- DATE         VERSION	          AUTHOR     HISTORY
-- 08/31/87     2.0               Allen      Updates
--
--	A number of changes have been made to version 1.0:
--
--	1)  The name of the abstraction is no longer FILE_TYPE,
--	    but is LINK_TYPE instead.  This just seemed to make
--	    more logical sense.  The only change made to the
--	    source to reflect this was the text substitution
--	    LINK for FILE throughout.  This includes the change
--	    from IN_FILE and OUT_FILE to IN_LINK and OUT_LINK
--	    for MODE_TYPE.  In old programs where you used
--	    version 1.0, just make the same global text
--	    substitution to upgrade, and recompile.
--
--	2)  The body has been changed to use the VAX's TASK_QIOW
--	    instead of STARLET.QIOW.  This means that now the
--	    network i/o READ and WRITE operation will not suspend
--	    the entire VMS process while waiting for completion,
--	    only the individual Ada task.
--
--	3)  The package no longer uses the VAX-specific 'MACHINE_SIZE
--	    attribute to determine the size of the message to be sent.
--	    Now 'SIZE is used on the object (as opposed to the type)
--	    to be sent.
--
--
--                                                           -*
------------------ Distribution and Copyright -----------------
--                                                           -*
-- This prologue must be included in all copies of this software.
--
-- This software is released to the Ada community.
-- This software is released to the Public Domain (note:
--   software released to the Public Domain is not subject
--   to copyright protection).
-- Restrictions on use or distribution:  NONE
--                                                           -*
------------------ Disclaimer ---------------------------------
--                                                           -*
-- This software and its documentation are provided "AS IS" and
-- without any expressed or implied warranties whatsoever.
-- No warranties as to performance, merchantability, or fitness
-- for a particular purpose exist.
--
-- Because of the diversity of conditions and hardware under
-- which this software may be used, no warranty of fitness for
-- a particular purpose is offered.  The user is advised to
-- test the software thoroughly before relying on it.  The user
-- must assume the entire risk and liability of using this
-- software.
--
-- In no event shall any person or organization of people be
-- held responsible for any direct, indirect, consequential
-- or inconsequential damages or lost profits.
--                                                           -*
-------------------END-PROLOGUE--------------------------------
-------
