
-------- SIMTEL20 Ada Software Repository Prologue ------------
--                                                           -*
-- Unit name    : SAFE_IO
-- Version      : 1.0
-- Author       : John A. Anderson
--              : TEXAS INSTRUMENTS MS 8006
--              : P.O. BOX 801
--              : MCKINNEY, TEXAS   75069
-- DDN Address  : ANDERSON%TI-EG@CSNET-RELAY
-- Copyright    : (c) 1984 John A. Anderson
-- Date created :  OCTOBER  2, 1984
-- Release date :  NOVEMBER 27, 1984
-- Last update  :  ANDERSON Wed Nov 27, 1984
-- Machine/System Compiled/Run on: DEC VAX/VMS, DEC Ada
--                                                           -*
---------------------------------------------------------------
--                                                           -*
-- Keywords     :  INPUT/OUTPUT
--
-- Abstract     :  This generic package allows the user to
----------------:  input data types from the keyboard
----------------:  while checking the input for errors. (Proper
----------------:  Type:  syntax and ranges.)
----------------:  A procedure for checking input of characters
----------------:  for a proper subrange of the character set is
----------------:  provided.
----------------:  When an error is encountered, an error message
----------------:  is displayed and the user is allowed to reenter.
----------------:  Output routines are provided to allow the user
----------------:  to do I/O with only one instantiation.  Screen
----------------:  manipulation (i.e. NEW_LINE) should be done with
----------------:  TEXT_IO directly.
----------------:  Instantiations require a FIELD_WIDTH which
----------------:  specifies the maximum field width for the input
----------------:  of the corresponding type.
--                                                           -*
------------------ Revision history ---------------------------
--                                                           -*
-- DATE         VERSION	AUTHOR                  HISTORY
-- 11/27/84	  1.0	Anderson		Initial Release
--                                                           -*
------------------ Distribution and Copyright -----------------
--                                                           -*
-- This prologue must be included in all copies of this software.
--
-- This software is copyright by the author.
--
-- This software is released to the Ada community.
-- This software is released to the Public Domain (note:
--   software released to the Public Domain is not subject
--   to copyright protection).
-- Restrictions on use or distribution:  NONE
--                                                           -*
------------------ Disclaimer ---------------------------------
--                                                           -*
-- This software and its documentation are provided "AS IS" and
-- without any expressed or implied warranties whatsoever.
-- No warranties as to performance, merchantability, or fitness
-- for a particular purpose exist.
--
-- Because of the diversity of conditions and hardware under
-- which this software may be used, no warranty of fitness for
-- a particular purpose is offered.  The user is advised to
-- test the software thoroughly before relying on it.  The user
-- must assume the entire risk and liability of using this
-- software.
--
-- In no event shall any person or organization of people be
-- held responsible for any direct, indirect, consequential
-- or inconsequential damages or lost profits.
--                                                           -*
-------------------END-PROLOGUE--------------------------------

