
-------- SIMTEL20 Ada Software Repository Prologue ------------
--                                                           -*
-- Unit name    : SYSDEP
-- Version      : 1.0
-- Author       : Stewart French, Richard Powers, Richard Conn
--              : Texas Instruments
--              : PO Box 801, MS 8007
--              : McKinney, TX  75069
-- DDN Address  : RCONN at SIMTEL20
-- Copyright    : (c) 1985 Richard Conn
-- Date created :  21 Jan 85
-- Release date :  21 Jan 85
-- Last update  :  21 Jan 85
-- Machine/System Compiled/Run on : DG MV 10000, ROLM ADE
--                                                           -*
---------------------------------------------------------------
--                                                           -*
-- Keywords     :  SYSTEM
----------------:  SYSTEM-DEPENDENCIES
--
-- Abstract     :  SYSDEP - System Dependency Package
----------------:  
----------------:  SYSDEP provides GET, PUT, and IS_VALID_CHARACTER
----------------:  as basic I/O routines which are defined as follows:
----------------:
----------------:  GET  - return the next character from the console
----------------:  without any interpretation (all 128 ASCII characters
----------------:  may be input with exceptions as noted by IS_VALID_CHARACTER)
----------------:  and without echo (echo must be supplied by the user)
----------------:
----------------:  PUT  - output the indicated character without interpretation
----------------:  (any valid character, noted by IS_VALID_CHARACTER, may be
----------------:  output by PUT
----------------:
----------------:  This simple pair of defined functions permits a more
----------------:  flexible and constant I/O configuration than that
----------------:  provided by TEXT_IO and opens up the door to future
----------------:  tools written in Ada, such as communications servers.
----------------:  Adaption of SYSDEP to interface thru CAIS definitions,
----------------:  when such definitions are established and placed in use,
----------------:  can be done at a later time.  OPEN_CONSOLE and CLOSE_CONSOLE
----------------:  must be called before the first use of PUT or GET and after
----------------:  the last use of PUT or GET, resp.
----------------:  
--                                                           -*
------------------ Revision history ---------------------------
--                                                           -*
-- DATE         VERSION	AUTHOR                  HISTORY
-- 1/21/85	  1.0	Richard Conn		Initial Release
--                                                           -*
------------------ Distribution and Copyright -----------------
--                                                           -*
-- This prologue must be included in all copies of this software.
--
-- This software is copyright by the author.
--
-- This software is released to the Ada community.
-- This software is released to the Public Domain (note:
--   software released to the Public Domain is not subject
--   to copyright protection).
-- Restrictions on use or distribution:  NONE
--                                                           -*
------------------ Disclaimer ---------------------------------
--                                                           -*
-- This software and its documentation are provided "AS IS" and
-- without any expressed or implied warranties whatsoever.
-- No warranties as to performance, merchantability, or fitness
-- for a particular purpose exist.
--
-- Because of the diversity of conditions and hardware under
-- which this software may be used, no warranty of fitness for
-- a particular purpose is offered.  The user is advised to
-- test the software thoroughly before relying on it.  The user
-- must assume the entire risk and liability of using this
-- software.
--
-- In no event shall any person or organization of people be
-- held responsible for any direct, indirect, consequential
-- or inconsequential damages or lost profits.
--                                                           -*
-------------------END-PROLOGUE--------------------------------
