-------- SIMTEL20 Ada Software Repository Prologue ------------
--                                                           -*
-- Unit name    :  VARIABLE_LENGTH_DIRECT_IO
-- Version      :  1.0
-- Author       :  Patrick Kopson 
--              : Texas Instruments  
--              :  
--              :  
-- DDN Address  :  WOODY%TI-EG@CSNET-RELAY
-- Copyright    :  (c) 1985
-- Date created :  01 APR 85
-- Release date :  03 DEC 85
-- Last update  :  03 DEC 85
-- Machine/System Compiled/Run on :  VAX 11/785  VMS 4.1
--                                   DEC Ada
--                                                           -*
---------------------------------------------------------------
--                                                           -*
-- Keywords     : DIRECT_IO, Varible-Length IO  
----------------:
--
-- Abstract     :  
--|   This is a package similar to DIRECT_IO that operates on records of
--|   variable length.  The body of this package may use CAIS utilities
--|   in the future.
--|
--|   This package allows the user to write elements of differing lengths to a
--|   single direct access file.  This package can be used to write data
--|   of all types to a single file (with the aid of UNCHECKED_CONVERSION).
--|   The DATA_FILE_IO package in the Ada repository serves as an example of
--|   how this can be accomplished.
--|
--|   This package also reduces the time-per-byte-of-data-transfered by reducing
--|   the number of calls to the run time libraray routines associated with the
--|   predefined generic package DIRECT_IO.  This is accomplished by placing
--|   many incoming records into a large buffer and then writng the entire 
--|   buffer to an external file as a single element (vice versa for reading).
--|   Bytes_Per_Block, the only generic parameter for this package, determines 
--|   the size (in bytes) of this buffer.
----------------:  
--                                                           -*
------------------ Revision history ---------------------------
--                                                           -*
-- DATE         VERSION	AUTHOR                  HISTORY
-- 12/3/85      1.0         Patrick Kopson          Initial Release
--                                                           -*
------------------ Distribution and Copyright -----------------
--                                                           -*
-- This prologue must be included in all copies of this software.
--
-- This software is copyright by the author.
--
-- This software is released to the Ada community.
-- This software is released to the Public Domain (note:
--   software released to the Public Domain is not subject
--   to copyright protection).
-- Restrictions on use or distribution:  NONE
--                                                           -*
------------------ Disclaimer ---------------------------------
--                                                           -*
-- This software and its documentation are provided "AS IS" and
-- without any expressed or implied warranties whatsoever.
-- No warranties as to performance, merchantability, or fitness
-- for a particular purpose exist.
--
-- Because of the diversity of conditions and hardware under
-- which this software may be used, no warranty of fitness for
-- a particular purpose is offered.  The user is advised to
-- test the software thoroughly before relying on it.  The user
-- must assume the entire risk and liability of using this
-- software.
--
-- In no event shall any person or organization of people be
-- held responsible for any direct, indirect, consequential
-- or inconsequential damages or lost profits.
--                                                           -*
-------------------END-PROLOGUE--------------------------------
