
-------- SIMTEL20 Ada Software Repository Prologue ------------
--                                                           -*
-- Unit name    : HELP System
-- Version      : 1.3
-- Author       : Richard Conn
--		: Echelon, Inc
-- DDN Address  : RCONN at SIMTEL20
-- Copyright    :
-- Date created :  1 Dec 85
-- Release date :  2 Mar 86
-- Last update  :  2 Mar 86
-- Machine/System Compiled/Run on : VAX 11/785 (VMS 4.2), DEC Ada
--                                                           -*
---------------------------------------------------------------
--                                                           -*
-- Keywords     :  Online documentation, HELP
--
-- Abstract     :  
-- The HELP System is a collection of programs which provide an interactive
-- online documentation facility.  Data for the facility is prepared as
-- a conventional text file which is formatted in an outline form, as follows:
--
--	0 Topic-Name
--		<text of topic>
--	1 1st-Level-Subtopic
--		<text of subtopic>
--	...
--	9 9th-Level-Subtopic
--		<text>
--	1 2nd-1st-Level-Subtopic
--		<text>
--	...
--	1 3rd-1st-Level-Subtopic
--	...
--	0 Next-Topic
--	...
--
-- The level numbers do not have to be consecutive, and the lower the
-- level number is, the higher its entry appears in the hierarchy (level 4
-- elements appear before level 6).  There may be as many topics at each
-- level as desired.  A line containing only a dot (.) character causes
-- a break between screens when the help file is displayed to the user:
--
--	this line appears on one screen
--	.
--	this line appears on the next screen (at the top)
--
-- The HELP System consists of three programs: HELP, HELP_BUILD, and
-- HELP_ANALYZE.
--
-- The HELP program is used to display information contained in a help file.
-- This information is in the form of a direct-access file created by the
-- HELP_BUILD program.  Briefly:
--
--		text of help file 
--			V
--		    HELP_BUILD
--			V
--		direct-access help file
--			V
--		HELP displays info to user
--
-- The HELP_ANALYZE program displays the structure hierarchy of a direct
-- access file which is created by HELP_BUILD.
--
--                                                           -*
------------------ Revision history ---------------------------
--                                                           -*
-- DATE         VERSION	AUTHOR                  HISTORY
-- 31 Dec 85	1.2	Richard Conn		Production Release
--  2 Mar 86    1.3     Richard Conn            Minor Revisions
--                                                           -*
------------------ Distribution and Copyright -----------------
--                                                           -*
-- This prologue must be included in all copies of this software.
--
-- This software is released to the Ada community.
-- This software is released to the Public Domain (note:
--   software released to the Public Domain is not subject
--   to copyright protection).
-- Restrictions on use or distribution:  NONE
--                                                           -*
------------------ Disclaimer ---------------------------------
--                                                           -*
-- This software and its documentation are provided "AS IS" and
-- without any expressed or implied warranties whatsoever.
-- No warranties as to performance, merchantability, or fitness
-- for a particular purpose exist.
--
-- Because of the diversity of conditions and hardware under
-- which this software may be used, no warranty of fitness for
-- a particular purpose is offered.  The user is advised to
-- test the software thoroughly before relying on it.  The user
-- must assume the entire risk and liability of using this
-- software.
--
-- In no event shall any person or organization of people be
-- held responsible for any direct, indirect, consequential
-- or inconsequential damages or lost profits.
--                                                           -*
-------------------END-PROLOGUE--------------------------------
