
-------- SIMTEL20 Ada Software Repository Prologue ------------
--                                                           -*
-- Unit name    : PAGER
-- Version      : 1.6
-- Author       : Richard Conn
--              : TI Ada Technology Branch
--              : PO Box 801, MS 8007
--              : McKinney, TX  75069
-- DDN Address  : RCONN at SIMTEL20
-- Copyright    : (c) 1985 by Richard Conn
-- Date created : 8 Apr 85
-- Release date : 8 Apr 85
-- Last update  : 30 Oct 85
-- Machine/System Compiled/Run on : DG MV10000, ROLM ADE
--                                  DEC VAX 11/785, DEC Ada
--                                                           -*
---------------------------------------------------------------
--                                                           -*
-- Keywords     : PAGED FILES, LIBRARY, REPOSITORY, PAGER, UNPAGE
----------------:
--
-- Abstract     : PAGER is a tool which creates, extracts from,
-- and scans paged files, where a paged file is a file composed
-- of one or more files prefixed by banners.  PAGER is based in
-- concept on the UNPAGE tool submitted to the Ada Repository on
-- SIMTEL20 by Mitre Corporation.
--
--      Paged files are convenient mechanisms for storing related files.
-- They reduce cluttering in the directories and simplify the file
-- transfer process (to and from the Ada Repository, for example) by
-- requiring the user to transfer only one file in order to obtain all
-- files pertinent to a particular project or tool.  Additionally, paged
-- files are text files which can be handled more readily than the 8-bit
-- binary images associated with other file grouping mechanisms.  Paged
-- files may be manipulated by a text editor if necessary.
--                                                           -*
------------------ Revision history ---------------------------
--                                                           -*
-- DATE         VERSION AUTHOR                  HISTORY
-- 4/8/1985       1.4   Richard Conn            Initial Release
-- 5/6/1985       1.5   Richard Conn            Numeric Error Trap Added
-- 10/30/1985	  1.6	Richard Conn		LIST Command Added
--                                                           -*
------------------ Distribution and Copyright -----------------
--                                                           -*
-- This prologue must be included in all copies of this software.
--
-- This software is copyright by the author.
--
-- This software is released to the Ada community.
-- This software is released to the Public Domain (note:
--   software released to the Public Domain is not subject
--   to copyright protection).
-- Restrictions on use or distribution:  NONE
--                                                           -*
------------------ Disclaimer ---------------------------------
--                                                           -*
-- This software and its documentation are provided "AS IS" and
-- without any expressed or implied warranties whatsoever.
-- No warranties as to performance, merchantability, or fitness
-- for a particular purpose exist.
--
-- Because of the diversity of conditions and hardware under
-- which this software may be used, no warranty of fitness for
-- a particular purpose is offered.  The user is advised to
-- test the software thoroughly before relying on it.  The user
-- must assume the entire risk and liability of using this
-- software.
--
-- In no event shall any person or organization of people be
-- held responsible for any direct, indirect, consequential
-- or inconsequential damages or lost profits.
--                                                           -*
-------------------END-PROLOGUE--------------------------------
