-- This is the universal specification for collecting output
-- Various bodies supplied on the distribution tape include :
--  A000042.ADA for screen or printed output
--  A000043.ADA for saving results on disk
--  A000044.ADA for saving result in memory ( No TEXT_IO )
--
--  CPU_DELTA and WALL_DELTA come from the package ITERATION.
--  These values are the time for one feature, in microseconds, of type
--  duration. Thus the limit is 86,400 microseconds.

package PIWG_IO is -- A000041.ADA

  SAVE_CPU_TIME : DURATION := 0.0 ; -- find this location in memory if using
  SAVE_WALL_TIME : DURATION := 0.0 ; -- A000044.ADA as body.

  procedure PIWG_OUTPUT ( TESTNAME : in STRING ; -- only 12 characters saved
                          CLASSNAME : in STRING ; -- only 12 characters saved
                          CPU_DELTA : in DURATION ; -- scaled microseconds
                          WALL_DELTA : in DURATION ; -- scaled microseconds
                          NUM_OF_ITERATIONS : in INTEGER ;
                          TEST_DESC_1 : in STRING ; -- only 80 characters saved
                          TEST_DESC_2 : in STRING ; -- only 80 characters saved
                          TEST_DESC_3 : in STRING ) ; -- ditto

-- Note that subtypes are not used because the calling programs would all
-- have to supply exactly the correct length strings for all parameters.

end PIWG_IO ;
