-- This is one of a number of optional PIWG_IO bodies.
-- This body is for systems that have TEXT_IO and want either
-- screen or printed output.

with TEXT_IO ; use TEXT_IO ;
with DURATION_IO ;  --  A000001.ADA or A000002.ADA

package body PIWG_IO is -- A000042.ADA

  procedure PIWG_OUTPUT ( TESTNAME : in STRING ;
                          CLASSNAME : in STRING ;
                          CPU_DELTA : in DURATION ;
                          WALL_DELTA : in DURATION ;
                          NUM_OF_ITERATIONS : in INTEGER ;
                          TEST_DESC_1 : in STRING ;
                          TEST_DESC_2 : in STRING ;
                          TEST_DESC_3 : in STRING ) is
  begin
    NEW_LINE ;
    PUT ( "Test Name:   " ) ;
    PUT ( TESTNAME ) ;
    PUT ( "                        Class Name:  " ) ;
    PUT_LINE ( CLASSNAME ) ;

    PUT ( "CPU Time:   " ) ;
    DURATION_IO.PUT ( CPU_DELTA , 6 , 1 ) ;
    PUT_LINE ( "  microseconds " ) ;

    PUT ( "Wall Time:  " ) ;
    DURATION_IO.PUT ( WALL_DELTA , 6 , 1 ) ;
    PUT ( "  microseconds.         Iteration Count:  " ) ;
    PUT_LINE ( INTEGER'IMAGE( NUM_OF_ITERATIONS )) ;

    PUT_LINE ( "Test Description:" ) ;
    PUT_LINE ( TEST_DESC_1 ) ;
    PUT_LINE ( TEST_DESC_2 ) ;
    PUT_LINE ( TEST_DESC_3 ) ;
    NEW_LINE ( 2 ) ;

  end PIWG_OUTPUT ;

end PIWG_IO ;
