-- PERFORMANCE MEASUREMENT : tasks entry call and return time
--                           1 task 10 entries
--                           one select statement

package TASK_PACK_6 is
  task T1 is
    entry E1 ;
    entry E2 ;
    entry E3 ;
    entry E4 ;
    entry E5 ;
    entry E6 ;
    entry E7 ;
    entry E8 ;
    entry E9 ;
    entry E10 ;
  end T1 ;
end TASK_PACK_6 ;

with TASK_PACK_6 ; use TASK_PACK_6 ;
with REMOTE_GLOBAL ; use REMOTE_GLOBAL ; -- control optimization
with ITERATION ; -- obtain stable measurement
with PIWG_IO ; -- output results


procedure T000006 is  -- main procedure to execute

  CPU_TIME : DURATION ; -- CPU time for one feature execution
  WALL_TIME : DURATION ; -- WALL time for one feature execution
  CHECK_TIMES : constant := 100 ; -- inside loop count and check
  ITERATION_COUNT : INTEGER ; -- set and varied by ITERATION package
  STABLE : BOOLEAN ; -- true when measurement stable
  CASE_COUNT : constant := 10 ;

begin

  ITERATION.START_CONTROL ;  -- dummy to bring in pages on some machines

  delay 0.5 ;  -- wait for stable enviornment on some machines

  ITERATION.INITIALIZE ( ITERATION_COUNT ) ;

  loop  -- until stable measurement, ITERATION_COUNT increases each time

--
-- Control loop
--
    ITERATION.START_CONTROL ;
    for J in 1 .. ITERATION_COUNT loop
      GLOBAL := 0 ;
      for INSIDE_LOOP in 1 .. INTEGER ( CHECK_TIMES * CASE_COUNT ) loop
        GLOBAL := GLOBAL + A_ONE ; 
        REMOTE ;                   
      end loop ;
    end loop ;
    ITERATION.STOP_CONTROL ( GLOBAL , CHECK_TIMES * CASE_COUNT ) ;

--
-- Test loop
--
    ITERATION.START_TEST ;
    for J in 1 .. ITERATION_COUNT loop
      GLOBAL := 0 ;
      for INSIDE_LOOP in 1 .. CHECK_TIMES loop
        T1.E5 ;
        T1.E7 ;
        T1.E2 ;
        T1.E1 ;
        T1.E10 ;
        T1.E3 ;
        T1.E9 ;
        T1.E8 ;
        T1.E4 ;
        T1.E6 ;
      end loop ;
    end loop ;
    ITERATION.STOP_TEST ( GLOBAL , CHECK_TIMES * CASE_COUNT ) ;
    ITERATION.TEST_STABLE ( ITERATION_COUNT , STABLE ) ;
    exit when STABLE ;
  end loop ;
--
  ITERATION.FEATURE_TIMES ( CPU_TIME , WALL_TIME ) ;

--
-- Printout
--
  PIWG_IO.PIWG_OUTPUT ( "T000006" , "TASKING" ,
                        CPU_TIME , WALL_TIME , ITERATION_COUNT ,
     " Task entry call and return time measurement" ,
     " One task with ten entries , task in a package " ,
     " one select statement, compare to T000005 " ) ;

  abort T1 ;

end T000006 ;

with REMOTE_GLOBAL ; use REMOTE_GLOBAL ;

package body TASK_PACK_6 is
  task body T1 is
  begin
    loop
      select
        accept E1 do
           GLOBAL := GLOBAL + A_ONE ;
           REMOTE ;
        end E1;
      or
        accept E2 do
           GLOBAL := GLOBAL + A_ONE ;
           REMOTE ;
        end E2;
      or
        accept E3 do
           GLOBAL := GLOBAL + A_ONE ;
           REMOTE ;
        end E3;
      or
        accept E4 do
           GLOBAL := GLOBAL + A_ONE ;
           REMOTE ;
        end E4;
      or
        accept E5 do
           GLOBAL := GLOBAL + A_ONE ;
           REMOTE ;
        end E5;
      or
        accept E6 do
           GLOBAL := GLOBAL + A_ONE ;
           REMOTE ;
        end E6;
      or
        accept E7 do
           GLOBAL := GLOBAL + A_ONE ;
           REMOTE ;
        end E7;
      or
        accept E8 do
           GLOBAL := GLOBAL + A_ONE ;
           REMOTE ;
        end E8;
      or
        accept E9 do
           GLOBAL := GLOBAL + A_ONE ;
           REMOTE ;
        end E9;
      or
        accept E10 do
           GLOBAL := GLOBAL + A_ONE ;
           REMOTE ;
        end E10;
      or
        terminate ;
      end select ;
    end loop ;
  end T1 ;

end TASK_PACK_6 ;
