with PHYSICAL_UNITS_MECHANICAL ; use PHYSICAL_UNITS_MECHANICAL ;

package PHYSICAL_UNITS_OUTPUT_MECHANICAL is

-- This package specification defines a simple PUT for Ada types for physical
-- quantities generally mechanical in nature.
--
-- Notice that there is not a procedure PUT defined for LENGTH_METER
-- or for that matter, any " subtype " defined in the package PHYSICAL_UNITS.
-- It is unnecessary and happens to be illegal ada.

  procedure PUT ( ITEM : AREA_MKS ) ;

  procedure PUT ( ITEM : AREA_ENGLISH ) ;

  procedure PUT ( ITEM : AREA_SQUARE_CENTIMETER ) ;

  procedure PUT ( ITEM : AREA_SQUARE_KILOMETER ) ;

  procedure PUT ( ITEM : AREA_SQUARE_INCH ) ;

  procedure PUT ( ITEM : AREA_SQUARE_YARD ) ;

  procedure PUT ( ITEM : AREA_SQUARE_MILE ) ;

  procedure PUT ( ITEM : AREA_ACRE ) ;

  procedure PUT ( ITEM : AREA_CIRCULAR_MIL ) ;

  procedure PUT ( ITEM : AREA_HECTARE ) ;

  procedure PUT ( ITEM : AREA_TOWNSHIP ) ;

  procedure PUT ( ITEM : VOLUME_MKS ) ;

  procedure PUT ( ITEM : VOLUME_ENGLISH ) ;

  procedure PUT ( ITEM : VOLUME_MILLILITER ) ;

  procedure PUT ( ITEM : VOLUME_LITER ) ;

  procedure PUT ( ITEM : VOLUME_KILOLITER ) ;

  procedure PUT ( ITEM : VOLUME_CUBIC_CENTIMETER ) ;

  procedure PUT ( ITEM : VOLUME_CUBIC_INCH ) ;

  procedure PUT ( ITEM : VOLUME_CUBIC_YARD ) ;

  procedure PUT ( ITEM : VOLUME_CUBIC_MILE ) ;

  procedure PUT ( ITEM : VOLUME_TEASPOON ) ;

  procedure PUT ( ITEM : VOLUME_TABLESPOON ) ;

  procedure PUT ( ITEM : VOLUME_OUNCE_FLUID ) ;

  procedure PUT ( ITEM : VOLUME_JIGGER ) ;

  procedure PUT ( ITEM : VOLUME_CUP ) ;

  procedure PUT ( ITEM : VOLUME_PINT_LIQUID ) ;

  procedure PUT ( ITEM : VOLUME_QUART_LIQUID ) ;

  procedure PUT ( ITEM : VOLUME_GALLON ) ;

  procedure PUT ( ITEM : VOLUME_KEG ) ;

  procedure PUT ( ITEM : VOLUME_BARREL ) ;

  procedure PUT ( ITEM : VOLUME_PINT_DRY ) ;

  procedure PUT ( ITEM : VOLUME_QUART_DRY ) ;

  procedure PUT ( ITEM : VOLUME_PECK ) ;

  procedure PUT ( ITEM : VOLUME_BUSHEL ) ;

  procedure PUT ( ITEM : VOLUME_CORD ) ;

  procedure PUT ( ITEM : VELOCITY_MKS ) ;

  procedure PUT ( ITEM : VELOCITY_ENGLISH ) ;

  procedure PUT ( ITEM : VELOCITY_CENTIMETER_PER_SECOND ) ;

  procedure PUT ( ITEM : VELOCITY_KILOMETER_PER_HOUR ) ;

  procedure PUT ( ITEM : VELOCITY_INCHES_PER_SECOND ) ;

  procedure PUT ( ITEM : VELOCITY_MILE_PER_HOUR ) ;

  procedure PUT ( ITEM : VELOCITY_MILES_PER_SECOND ) ;

  procedure PUT ( ITEM : VELOCITY_INCHES_PER_MINUTE ) ;

  procedure PUT ( ITEM : VELOCITY_FEET_PER_MINUTE ) ;

  procedure PUT ( ITEM : VELOCITY_MILES_PER_HOUR ) ;

  procedure PUT ( ITEM : VELOCITY_KNOTS ) ;

  procedure PUT ( ITEM : VELOCITY_FURLONG_PER_FORTNIGHT ) ;

  procedure PUT ( ITEM : ANGULAR_VELOCITY ) ;

  procedure PUT ( ITEM : ANGULAR_VELOCITY_DEGREES_PER_SECOND ) ;

  procedure PUT ( ITEM : ANGULAR_VELOCITY_REVOLUTIONS_PER_MINUTE ) ;

  procedure PUT ( ITEM : ANGULAR_VELOCITY_REVOLUTIONS_PER_SECOND ) ;

  procedure PUT ( ITEM : ACCELERATION_MKS ) ;

  procedure PUT ( ITEM : ACCELERATION_ENGLISH ) ;

  procedure PUT ( ITEM : ANGULAR_ACCELERATION ) ;

  procedure PUT ( ITEM : ANGULAR_ACCELERATION_REVOLUTIONS_PER_MINUTE_SQUARED )
      ;

  procedure PUT ( ITEM : FORCE_MKS ) ;

  procedure PUT ( ITEM : FORCE_DYNE ) ;

  procedure PUT ( ITEM : FORCE_ENGLISH ) ;

  procedure PUT ( ITEM : ENERGY_MKS ) ;

  procedure PUT ( ITEM : ENERGY_ERG ) ;

  procedure PUT ( ITEM : ENERGY_GRAM_CALORIE ) ;

  procedure PUT ( ITEM : ENERGY_KILOGRAM_CALORIE ) ;

  procedure PUT ( ITEM : ENERGY_B_T_U ) ;

  procedure PUT ( ITEM : ENERGY_FOOT_POUND ) ;

  procedure PUT ( ITEM : ENERGY_KILOWATT_HOUR ) ;

  procedure PUT ( ITEM : ENERGY_HORSEPOWER_HOUR ) ;

  procedure PUT ( ITEM : POWER_MKS ) ;

  procedure PUT ( ITEM : POWER_KILOGRAM_CALORIE_PER_SECOND ) ;

  procedure PUT ( ITEM : POWER_KILOGRAN_CALORIE_PER_MINUTE ) ;

  procedure PUT ( ITEM : POWER_HORSEPOWER_MECHANICAL ) ;

  procedure PUT ( ITEM : POWER_HORSEPOWER_ELECTRICAL ) ;

  procedure PUT ( ITEM : POWER_HORSEPOWER_METRIC ) ;

  procedure PUT ( ITEM : POWER_HORSEPOWER_BOILER ) ;

  procedure PUT ( ITEM : POWER_B_T_U_PER_MINUTE ) ;

  procedure PUT ( ITEM : POWER_B_T_U_PER_HOUR ) ;

  procedure PUT ( ITEM : POWER_FOOT_POUND_PER_MINUTE ) ;

  procedure PUT ( ITEM : POWER_FOOT_POUND_PER_SECOND ) ;

  procedure PUT ( ITEM : DENSITY_MKS ) ;

  procedure PUT ( ITEM : DENSITY_ENGLISH ) ;

  procedure PUT ( ITEM : FLOW_RATE_MKS ) ;

  procedure PUT ( ITEM : FLOW_RATE_GALLON_PER_MINUTE ) ;

  procedure PUT ( ITEM : FLOW_RATE_ENGLISH ) ;

  procedure PUT ( ITEM : FLOW_RATE_CUBIC_FEET_PER_MINUTE ) ;

  procedure PUT ( ITEM : PRESSURE_MKS ) ;

  procedure PUT ( ITEM : PRESSURE_ENGLISH ) ;

  procedure PUT ( ITEM : PRESSURE_TON_PER_SQUARE_FOOT ) ;

  procedure PUT ( ITEM : PRESSURE_ATMOSPHERE_STANDARD ) ;

  procedure PUT ( ITEM : PRESSURE_FEET_OF_WATER ) ;

  procedure PUT ( ITEM : PRESSURE_INCHES_OF_MERCURY ) ;

  procedure PUT ( ITEM : PRESSURE_MILLIMETER_OF_MERCURY ) ;

  procedure PUT ( ITEM : PRESSURE_BAR ) ;

  procedure PUT ( ITEM : PRESSURE_MILLIBAR ) ;

  procedure PUT ( ITEM : PRESSURE_TORR ) ;

  procedure PUT ( ITEM : MOMENTUM_MKS ) ;

  procedure PUT ( ITEM : INERTIA_MKS ) ;

  procedure PUT ( ITEM : MOMENT_OF_INERTIA_MKS ) ;

  procedure PUT ( ITEM : KINEMATIC_VISCOSITY_MKS ) ;

  procedure PUT ( ITEM : DYNAMIC_VISCOSITY_MKS ) ;

  procedure PUT ( ITEM : LUMINOUS_FLUX_LUMEN ) ;

  procedure PUT ( ITEM : ILLUMINATION_MKS ) ;

  procedure PUT ( ITEM : LUMINANCE_MKS ) ;

  procedure PUT ( ITEM : ENTROPY_MKS ) ;

  procedure PUT ( ITEM : SPECIFIC_HEAT_B_T_U_PER_POUND_DEGREE_FARENHEIT ) ;

end PHYSICAL_UNITS_OUTPUT_MECHANICAL ;
with PHYSICAL_REAL ; use PHYSICAL_REAL ;
with TEXT_IO ; use TEXT_IO ;
with FLT_IO ; use FLT_IO ;

package body PHYSICAL_UNITS_OUTPUT_MECHANICAL is

  procedure PUT ( ITEM : AREA_MKS ) is

  begin
    PUT ( UNDIMENSION( ITEM )) ;
    PUT ( " square meter" ) ;
  end PUT ;

  procedure PUT ( ITEM : AREA_ENGLISH ) is

  begin
    PUT ( UNDIMENSION( ITEM )) ;
    PUT ( " square foot " ) ;
  end PUT ;

  procedure PUT ( ITEM : AREA_SQUARE_CENTIMETER ) is

  begin
    PUT ( UNDIMENSION( ITEM )) ;
    PUT ( " square centimeter " ) ;
  end PUT ;

  procedure PUT ( ITEM : AREA_SQUARE_KILOMETER ) is

  begin
    PUT ( UNDIMENSION( ITEM )) ;
    PUT ( " square kilometer " ) ;
  end PUT ;

  procedure PUT ( ITEM : AREA_SQUARE_INCH ) is

  begin
    PUT ( UNDIMENSION( ITEM )) ;
    PUT ( " square inch " ) ;
  end PUT ;

  procedure PUT ( ITEM : AREA_SQUARE_YARD ) is

  begin
    PUT ( UNDIMENSION( ITEM )) ;
    PUT ( " square yard " ) ;
  end PUT ;

  procedure PUT ( ITEM : AREA_SQUARE_MILE ) is

  begin
    PUT ( UNDIMENSION( ITEM )) ;
    PUT ( " square mile " ) ;
  end PUT ;

  procedure PUT ( ITEM : AREA_ACRE ) is

  begin
    PUT ( UNDIMENSION( ITEM )) ;
    PUT ( " acre " ) ;
  end PUT ;

  procedure PUT ( ITEM : AREA_CIRCULAR_MIL ) is

  begin
    PUT ( UNDIMENSION( ITEM )) ;
    PUT ( " circular mil " ) ;
  end PUT ;

  procedure PUT ( ITEM : AREA_HECTARE ) is

  begin
    PUT ( UNDIMENSION( ITEM )) ;
    PUT ( " hectare " ) ;
  end PUT ;

  procedure PUT ( ITEM : AREA_TOWNSHIP ) is

  begin
    PUT ( UNDIMENSION( ITEM )) ;
    PUT ( " township " ) ;
  end PUT ;

  procedure PUT ( ITEM : VOLUME_MKS ) is

  begin
    PUT ( UNDIMENSION( ITEM )) ;
    PUT ( " cubic meter " ) ;
  end PUT ;

  procedure PUT ( ITEM : VOLUME_ENGLISH ) is

  begin
    PUT ( UNDIMENSION( ITEM )) ;
    PUT ( " cubic foot " ) ;
  end PUT ;

  procedure PUT ( ITEM : VOLUME_MILLILITER ) is

  begin
    PUT ( UNDIMENSION( ITEM )) ;
    PUT ( " milliliter " ) ;
  end PUT ;

  procedure PUT ( ITEM : VOLUME_LITER ) is

  begin
    PUT ( UNDIMENSION( ITEM )) ;
    PUT ( " liter " ) ;
  end PUT ;

  procedure PUT ( ITEM : VOLUME_KILOLITER ) is

  begin
    PUT ( UNDIMENSION( ITEM )) ;
    PUT ( " kiloliter " ) ;
  end PUT ;

  procedure PUT ( ITEM : VOLUME_CUBIC_CENTIMETER ) is

  begin
    PUT ( UNDIMENSION( ITEM )) ;
    PUT ( " cubic centimeter " ) ;
  end PUT ;

  procedure PUT ( ITEM : VOLUME_CUBIC_INCH ) is

  begin
    PUT ( UNDIMENSION( ITEM )) ;
    PUT ( " cubic inch " ) ;
  end PUT ;

  procedure PUT ( ITEM : VOLUME_CUBIC_YARD ) is

  begin
    PUT ( UNDIMENSION( ITEM )) ;
    PUT ( " cubic yard " ) ;
  end PUT ;

  procedure PUT ( ITEM : VOLUME_CUBIC_MILE ) is

  begin
    PUT ( UNDIMENSION( ITEM )) ;
    PUT ( " cubic mile " ) ;
  end PUT ;

  procedure PUT ( ITEM : VOLUME_TEASPOON ) is

  begin
    PUT ( UNDIMENSION( ITEM )) ;
    PUT ( " teaspoon " ) ;
  end PUT ;

  procedure PUT ( ITEM : VOLUME_TABLESPOON ) is

  begin
    PUT ( UNDIMENSION( ITEM )) ;
    PUT ( " tablespoon " ) ;
  end PUT ;

  procedure PUT ( ITEM : VOLUME_OUNCE_FLUID ) is

  begin
    PUT ( UNDIMENSION( ITEM )) ;
    PUT ( " ounce (fluid) " ) ;
  end PUT ;

  procedure PUT ( ITEM : VOLUME_JIGGER ) is

  begin
    PUT ( UNDIMENSION( ITEM )) ;
    PUT ( " jigger " ) ;
  end PUT ;

  procedure PUT ( ITEM : VOLUME_CUP ) is

  begin
    PUT ( UNDIMENSION( ITEM )) ;
    PUT ( " cup " ) ;
  end PUT ;

  procedure PUT ( ITEM : VOLUME_PINT_LIQUID ) is

  begin
    PUT ( UNDIMENSION( ITEM )) ;
    PUT ( " pint (liquid) " ) ;
  end PUT ;

  procedure PUT ( ITEM : VOLUME_QUART_LIQUID ) is

  begin
    PUT ( UNDIMENSION( ITEM )) ;
    PUT ( " quart (liquid) " ) ;
  end PUT ;

  procedure PUT ( ITEM : VOLUME_GALLON ) is

  begin
    PUT ( UNDIMENSION( ITEM )) ;
    PUT ( " gallon " ) ;
  end PUT ;

  procedure PUT ( ITEM : VOLUME_KEG ) is

  begin
    PUT ( UNDIMENSION( ITEM )) ;
    PUT ( " keg " ) ;
  end PUT ;

  procedure PUT ( ITEM : VOLUME_BARREL ) is

  begin
    PUT ( UNDIMENSION( ITEM )) ;
    PUT ( " barrel " ) ;
  end PUT ;

  procedure PUT ( ITEM : VOLUME_PINT_DRY ) is

  begin
    PUT ( UNDIMENSION( ITEM )) ;
    PUT ( " pint (dry) " ) ;
  end PUT ;

  procedure PUT ( ITEM : VOLUME_QUART_DRY ) is

  begin
    PUT ( UNDIMENSION( ITEM )) ;
    PUT ( " quart (dry) " ) ;
  end PUT ;

  procedure PUT ( ITEM : VOLUME_PECK ) is

  begin
    PUT ( UNDIMENSION( ITEM )) ;
    PUT ( " peck " ) ;
  end PUT ;

  procedure PUT ( ITEM : VOLUME_BUSHEL ) is

  begin
    PUT ( UNDIMENSION( ITEM )) ;
    PUT ( " bushel " ) ;
  end PUT ;

  procedure PUT ( ITEM : VOLUME_CORD ) is

  begin
    PUT ( UNDIMENSION( ITEM )) ;
    PUT ( " cord " ) ;
  end PUT ;

  procedure PUT ( ITEM : VELOCITY_MKS ) is

  begin
    PUT ( UNDIMENSION( ITEM )) ;
    PUT ( " meter per second " ) ;
  end PUT ;

  procedure PUT ( ITEM : VELOCITY_ENGLISH ) is

  begin
    PUT ( UNDIMENSION( ITEM )) ;
    PUT ( " foot per second " ) ;
  end PUT ;

  procedure PUT ( ITEM : VELOCITY_CENTIMETER_PER_SECOND ) is

  begin
    PUT ( UNDIMENSION( ITEM )) ;
    PUT ( " centimeter per second " ) ;
  end PUT ;

  procedure PUT ( ITEM : VELOCITY_KILOMETER_PER_HOUR ) is

  begin
    PUT ( UNDIMENSION( ITEM )) ;
    PUT ( " kilometer per hour " ) ;
  end PUT ;

  procedure PUT ( ITEM : VELOCITY_INCHES_PER_SECOND ) is

  begin
    PUT ( UNDIMENSION( ITEM )) ;
    PUT ( " inches per second " ) ;
  end PUT ;

  procedure PUT ( ITEM : VELOCITY_MILE_PER_HOUR ) is

  begin
    PUT ( UNDIMENSION( ITEM )) ;
    PUT ( " mile per hour " ) ;
  end PUT ;

  procedure PUT ( ITEM : VELOCITY_MILES_PER_SECOND ) is

  begin
    PUT ( UNDIMENSION( ITEM )) ;
    PUT ( " miles per second " ) ;
  end PUT ;

  procedure PUT ( ITEM : VELOCITY_INCHES_PER_MINUTE ) is

  begin
    PUT ( UNDIMENSION( ITEM )) ;
    PUT ( " inches per minute " ) ;
  end PUT ;

  procedure PUT ( ITEM : VELOCITY_FEET_PER_MINUTE ) is

  begin
    PUT ( UNDIMENSION( ITEM )) ;
    PUT ( " feet per minute " ) ;
  end PUT ;

  procedure PUT ( ITEM : VELOCITY_MILES_PER_HOUR ) is

  begin
    PUT ( UNDIMENSION( ITEM )) ;
    PUT ( " miles per hour " ) ;
  end PUT ;

  procedure PUT ( ITEM : VELOCITY_KNOTS ) is

  begin
    PUT ( UNDIMENSION( ITEM )) ;
    PUT ( " knots " ) ;
  end PUT ;

  procedure PUT ( ITEM : VELOCITY_FURLONG_PER_FORTNIGHT ) is

  begin
    PUT ( UNDIMENSION( ITEM )) ;
    PUT ( " furlong per fortnight " ) ;
  end PUT ;

  procedure PUT ( ITEM : ANGULAR_VELOCITY ) is

  begin
    PUT ( UNDIMENSION( ITEM )) ;
    PUT ( " radian per second " ) ;
  end PUT ;

  procedure PUT ( ITEM : ANGULAR_VELOCITY_DEGREES_PER_SECOND ) is

  begin
    PUT ( UNDIMENSION( ITEM )) ;
    PUT ( " degrees per second " ) ;
  end PUT ;

  procedure PUT ( ITEM : ANGULAR_VELOCITY_REVOLUTIONS_PER_MINUTE ) is

  begin
    PUT ( UNDIMENSION( ITEM )) ;
    PUT ( " revolutions per minute " ) ;
  end PUT ;

  procedure PUT ( ITEM : ANGULAR_VELOCITY_REVOLUTIONS_PER_SECOND ) is

  begin
    PUT ( UNDIMENSION( ITEM )) ;
    PUT ( " revolutions per second " ) ;
  end PUT ;

  procedure PUT ( ITEM : ACCELERATION_MKS ) is

  begin
    PUT ( UNDIMENSION( ITEM )) ;
    PUT ( " meter per second squared " ) ;
  end PUT ;

  procedure PUT ( ITEM : ACCELERATION_ENGLISH ) is

  begin
    PUT ( UNDIMENSION( ITEM )) ;
    PUT ( " foot per second squared " ) ;
  end PUT ;

  procedure PUT ( ITEM : ANGULAR_ACCELERATION ) is

  begin
    PUT ( UNDIMENSION( ITEM )) ;
    PUT ( " radians per second squared " ) ;
  end PUT ;

  procedure PUT ( ITEM : ANGULAR_ACCELERATION_REVOLUTIONS_PER_MINUTE_SQUARED )
      is

  begin
    PUT ( UNDIMENSION( ITEM )) ;
    PUT ( " revolutions per minute squared " ) ;
  end PUT ;

  procedure PUT ( ITEM : FORCE_MKS ) is

  begin
    PUT ( UNDIMENSION( ITEM )) ;
    PUT ( " newton " ) ;
  end PUT ;

  procedure PUT ( ITEM : FORCE_DYNE ) is

  begin
    PUT ( UNDIMENSION( ITEM )) ;
    PUT ( " dyne " ) ;
  end PUT ;

  procedure PUT ( ITEM : FORCE_ENGLISH ) is

  begin
    PUT ( UNDIMENSION( ITEM )) ;
    PUT ( " poundal " ) ;
  end PUT ;

  procedure PUT ( ITEM : ENERGY_MKS ) is

  begin
    PUT ( UNDIMENSION( ITEM )) ;
    PUT ( " joule " ) ;
  end PUT ;

  procedure PUT ( ITEM : ENERGY_ERG ) is

  begin
    PUT ( UNDIMENSION( ITEM )) ;
    PUT ( " erg " ) ;
  end PUT ;

  procedure PUT ( ITEM : ENERGY_GRAM_CALORIE ) is

  begin
    PUT ( UNDIMENSION( ITEM )) ;
    PUT ( " gram calorie " ) ;
  end PUT ;

  procedure PUT ( ITEM : ENERGY_KILOGRAM_CALORIE ) is

  begin
    PUT ( UNDIMENSION( ITEM )) ;
    PUT ( " kilogram calorie " ) ;
  end PUT ;

  procedure PUT ( ITEM : ENERGY_B_T_U ) is

  begin
    PUT ( UNDIMENSION( ITEM )) ;
    PUT ( " B.T.U. " ) ;
  end PUT ;

  procedure PUT ( ITEM : ENERGY_FOOT_POUND ) is

  begin
    PUT ( UNDIMENSION( ITEM )) ;
    PUT ( " foot pound " ) ;
  end PUT ;

  procedure PUT ( ITEM : ENERGY_KILOWATT_HOUR ) is

  begin
    PUT ( UNDIMENSION( ITEM )) ;
    PUT ( " kilowat hour " ) ;
  end PUT ;

  procedure PUT ( ITEM : ENERGY_HORSEPOWER_HOUR ) is

  begin
    PUT ( UNDIMENSION( ITEM )) ;
    PUT ( " horsepower hour " ) ;
  end PUT ;

  procedure PUT ( ITEM : POWER_MKS ) is

  begin
    PUT ( UNDIMENSION( ITEM )) ;
    PUT ( " watt " ) ;
  end PUT ;

  procedure PUT ( ITEM : POWER_KILOGRAM_CALORIE_PER_SECOND ) is

  begin
    PUT ( UNDIMENSION( ITEM )) ;
    PUT ( " kilogram calorie per second " ) ;
  end PUT ;

  procedure PUT ( ITEM : POWER_KILOGRAN_CALORIE_PER_MINUTE ) is

  begin
    PUT ( UNDIMENSION( ITEM )) ;
    PUT ( " kilogram calorie per minute " ) ;
  end PUT ;

  procedure PUT ( ITEM : POWER_HORSEPOWER_MECHANICAL ) is

  begin
    PUT ( UNDIMENSION( ITEM )) ;
    PUT ( " horsepower (mechanical) " ) ;
  end PUT ;

  procedure PUT ( ITEM : POWER_HORSEPOWER_ELECTRICAL ) is

  begin
    PUT ( UNDIMENSION( ITEM )) ;
    PUT ( " horsepower (electrical) " ) ;
  end PUT ;

  procedure PUT ( ITEM : POWER_HORSEPOWER_METRIC ) is

  begin
    PUT ( UNDIMENSION( ITEM )) ;
    PUT ( " horsepower ( metric) " ) ;
  end PUT ;

  procedure PUT ( ITEM : POWER_HORSEPOWER_BOILER ) is

  begin
    PUT ( UNDIMENSION( ITEM )) ;
    PUT ( " horsepower (boiler) " ) ;
  end PUT ;

  procedure PUT ( ITEM : POWER_B_T_U_PER_MINUTE ) is

  begin
    PUT ( UNDIMENSION( ITEM )) ;
    PUT ( " B.T.U. per minute " ) ;
  end PUT ;

  procedure PUT ( ITEM : POWER_B_T_U_PER_HOUR ) is

  begin
    PUT ( UNDIMENSION( ITEM )) ;
    PUT ( " B.T.U. per hour " ) ;
  end PUT ;

  procedure PUT ( ITEM : POWER_FOOT_POUND_PER_MINUTE ) is

  begin
    PUT ( UNDIMENSION( ITEM )) ;
    PUT ( " foot pound per minute " ) ;
  end PUT ;

  procedure PUT ( ITEM : POWER_FOOT_POUND_PER_SECOND ) is

  begin
    PUT ( UNDIMENSION( ITEM )) ;
    PUT ( " foot pound per second " ) ;
  end PUT ;

  procedure PUT ( ITEM : DENSITY_MKS ) is

  begin
    PUT ( UNDIMENSION( ITEM )) ;
    PUT ( " kilogram per cubic meter " ) ;
  end PUT ;

  procedure PUT ( ITEM : DENSITY_ENGLISH ) is

  begin
    PUT ( UNDIMENSION( ITEM )) ;
    PUT ( " pound per cubic foot " ) ;
  end PUT ;

  procedure PUT ( ITEM : FLOW_RATE_MKS ) is

  begin
    PUT ( UNDIMENSION( ITEM )) ;
    PUT ( " cubic meter per second " ) ;
  end PUT ;

  procedure PUT ( ITEM : FLOW_RATE_GALLON_PER_MINUTE ) is

  begin
    PUT ( UNDIMENSION( ITEM )) ;
    PUT ( " gallon per minute " ) ;
  end PUT ;

  procedure PUT ( ITEM : FLOW_RATE_ENGLISH ) is

  begin
    PUT ( UNDIMENSION( ITEM )) ;
    PUT ( " cubic feet per second " ) ;
  end PUT ;

  procedure PUT ( ITEM : FLOW_RATE_CUBIC_FEET_PER_MINUTE ) is

  begin
    PUT ( UNDIMENSION( ITEM )) ;
    PUT ( " cubic feet per minute " ) ;
  end PUT ;

  procedure PUT ( ITEM : PRESSURE_MKS ) is

  begin
    PUT ( UNDIMENSION( ITEM )) ;
    PUT ( " pascal " ) ;
  end PUT ;

  procedure PUT ( ITEM : PRESSURE_ENGLISH ) is

  begin
    PUT ( UNDIMENSION( ITEM )) ;
    PUT ( " pound per square foot " ) ;
  end PUT ;

  procedure PUT ( ITEM : PRESSURE_TON_PER_SQUARE_FOOT ) is

  begin
    PUT ( UNDIMENSION( ITEM )) ;
    PUT ( " ton per square foot " ) ;
  end PUT ;

  procedure PUT ( ITEM : PRESSURE_ATMOSPHERE_STANDARD ) is

  begin
    PUT ( UNDIMENSION( ITEM )) ;
    PUT ( " atmosphere " ) ;
  end PUT ;

  procedure PUT ( ITEM : PRESSURE_FEET_OF_WATER ) is

  begin
    PUT ( UNDIMENSION( ITEM )) ;
    PUT ( " feet of water " ) ;
  end PUT ;

  procedure PUT ( ITEM : PRESSURE_INCHES_OF_MERCURY ) is

  begin
    PUT ( UNDIMENSION( ITEM )) ;
    PUT ( " inches of mercury " ) ;
  end PUT ;

  procedure PUT ( ITEM : PRESSURE_MILLIMETER_OF_MERCURY ) is

  begin
    PUT ( UNDIMENSION( ITEM )) ;
    PUT ( " millimeter of mercury " ) ;
  end PUT ;

  procedure PUT ( ITEM : PRESSURE_BAR ) is

  begin
    PUT ( UNDIMENSION( ITEM )) ;
    PUT ( " bar " ) ;
  end PUT ;

  procedure PUT ( ITEM : PRESSURE_MILLIBAR ) is

  begin
    PUT ( UNDIMENSION( ITEM )) ;
    PUT ( " millibar " ) ;
  end PUT ;

  procedure PUT ( ITEM : PRESSURE_TORR ) is

  begin
    PUT ( UNDIMENSION( ITEM )) ;
    PUT ( " torr " ) ;
  end PUT ;

  procedure PUT ( ITEM : MOMENTUM_MKS ) is

  begin
    PUT ( UNDIMENSION( ITEM )) ;
    PUT ( " newton per second " ) ;
  end PUT ;

  procedure PUT ( ITEM : INERTIA_MKS ) is

  begin
    PUT ( UNDIMENSION( ITEM )) ;
    PUT ( " joule second " ) ;
  end PUT ;

  procedure PUT ( ITEM : MOMENT_OF_INERTIA_MKS ) is

  begin
    PUT ( UNDIMENSION( ITEM )) ;
    PUT ( " kilogram meter squared " ) ;
  end PUT ;

  procedure PUT ( ITEM : KINEMATIC_VISCOSITY_MKS ) is

  begin
    PUT ( UNDIMENSION( ITEM )) ;
    PUT ( " meter squared per second " ) ;
  end PUT ;

  procedure PUT ( ITEM : DYNAMIC_VISCOSITY_MKS ) is

  begin
    PUT ( UNDIMENSION( ITEM )) ;
    PUT ( " newton second per square meter " ) ;
  end PUT ;

  procedure PUT ( ITEM : LUMINOUS_FLUX_LUMEN ) is

  begin
    PUT ( UNDIMENSION( ITEM )) ;
    PUT ( " lumen " ) ;
  end PUT ;

  procedure PUT ( ITEM : ILLUMINATION_MKS ) is

  begin
    PUT ( UNDIMENSION( ITEM )) ;
    PUT ( " lumen per square meter " ) ;
  end PUT ;

  procedure PUT ( ITEM : LUMINANCE_MKS ) is

  begin
    PUT ( UNDIMENSION( ITEM )) ;
    PUT ( " lux " ) ;
  end PUT ;

  procedure PUT ( ITEM : ENTROPY_MKS ) is

  begin
    PUT ( UNDIMENSION( ITEM )) ;
    PUT ( " joule per degree centegrade " ) ;
  end PUT ;

  procedure PUT ( ITEM : SPECIFIC_HEAT_B_T_U_PER_POUND_DEGREE_FARENHEIT ) is

  begin
    PUT ( UNDIMENSION( ITEM )) ;
    PUT ( " B.T.U. per pound degree farenheit " ) ;
  end PUT ;

end PHYSICAL_UNITS_OUTPUT_MECHANICAL ;
