with PHYSICAL_UNITS_ELECTRICAL ; use PHYSICAL_UNITS_ELECTRICAL ;

package PHYSICAL_UNITS_OUTPUT_ELECTRICAL is

-- This package specification defines a simple PUT for Ada types for physical
-- quantities of electrical units.
--
-- Notice that there is not a procedure PUT defined for LENGTH_METER
-- or for that matter, any " subtype " defined in the package PHYSICAL_UNITS.
-- It is unnecessary and happens to be illegal ada.

  procedure PUT ( ITEM : CURRENT_AMPERE ) ;

  procedure PUT ( ITEM : CURRENT_MILLIAMPERE ) ;

  procedure PUT ( ITEM : CURRENT_MICROAMPERE ) ;

  procedure PUT ( ITEM : CURRENT_ABAMPERE ) ;

  procedure PUT ( ITEM : CURRENT_STATAMPERE ) ;

  procedure PUT ( ITEM : VOLTAGE_VOLT ) ;

  procedure PUT ( ITEM : VOLTAGE_MILLIVOLT ) ;

  procedure PUT ( ITEM : VOLTAGE_MICROVOLT ) ;

  procedure PUT ( ITEM : VOLTAGE_KILOVOLT ) ;

  procedure PUT ( ITEM : RESISTANCE_OHM ) ;

  procedure PUT ( ITEM : RESISTANCE_MILLIOHM ) ;

  procedure PUT ( ITEM : RESISTANCE_KILOHM ) ;

  procedure PUT ( ITEM : RESISTANCE_MEGOHM ) ;

  procedure PUT ( ITEM : RESISTIVITY_OHM_METER ) ;

  procedure PUT ( ITEM : CONDUCTANCE_MHO ) ;

  procedure PUT ( ITEM : CONDUCTIVITY_MHO_PER_METER ) ;

  procedure PUT ( ITEM : CAPACITANCE_FARAD ) ;

  procedure PUT ( ITEM : CAPACITANCE_MICROFARAD ) ;

  procedure PUT ( ITEM : CAPACITANCE_PICOFARAD ) ;

  procedure PUT ( ITEM : INDUCTANCE_HENRY ) ;

  procedure PUT ( ITEM : INDUCTANCE_MILLIHENRY ) ;

  procedure PUT ( ITEM : INDUCTANCE_MICROHENRY ) ;

  procedure PUT ( ITEM : CURRENT_DENSITY_AMPERE_PER_SQUARE_METER ) ;

  procedure PUT ( ITEM : CHARGE_DENSITY_COULOMB_PER_CUBIC_METER ) ;

  procedure PUT ( ITEM : MAGNETIC_FLUX_WEBER ) ;

  procedure PUT ( ITEM : MAGNETIC_FLUX_DENSITY_TESLA ) ;

  procedure PUT ( ITEM : MAGNETIC_INTENSITY_AMPERE_PER_METER ) ;

  procedure PUT ( ITEM : MAGNETIC_VECTOR_POTENTIAL_WEBER_PER_METER ) ;

  procedure PUT ( ITEM : ELECTRIC_FIELD_INTENSITY_VOLT_PER_METER ) ;

  procedure PUT ( ITEM : ELECTRIC_DISPLACEMENT_COULOMB_PER_SQUARE_METER ) ;

  procedure PUT ( ITEM : PERMEABILITY_HENRY_PER_METER ) ;

  procedure PUT ( ITEM : PERMITTIVITY_FARAD_PER_METER ) ;

  procedure PUT ( ITEM : FREQUENCY_HERTZ ) ;

  procedure PUT ( ITEM : FREQUENCY_KILOHERTZ ) ;

  procedure PUT ( ITEM : FREQUENCY_MEGAHERTZ ) ;

  procedure PUT ( ITEM : FREQUENCY_GIGAHERTZ ) ;

  procedure PUT ( ITEM : ANGULAR_FREQUENCY_RADIAN_PER_SECOND ) ;

--
end PHYSICAL_UNITS_OUTPUT_ELECTRICAL ;
with PHYSICAL_REAL ; use PHYSICAL_REAL ;
with TEXT_IO ; use TEXT_IO ;
with FLT_IO ; use FLT_IO ;

package body PHYSICAL_UNITS_OUTPUT_ELECTRICAL is

  procedure PUT ( ITEM : CURRENT_AMPERE ) is

  begin
    PUT ( UNDIMENSION( ITEM )) ;
    PUT ( " ampere " ) ;
  end PUT ;

  procedure PUT ( ITEM : CURRENT_MILLIAMPERE ) is

  begin
    PUT ( UNDIMENSION( ITEM )) ;
    PUT ( " milliampere " ) ;
  end PUT ;

  procedure PUT ( ITEM : CURRENT_MICROAMPERE ) is

  begin
    PUT ( UNDIMENSION( ITEM )) ;
    PUT ( " microampere " ) ;
  end PUT ;

  procedure PUT ( ITEM : CURRENT_ABAMPERE ) is

  begin
    PUT ( UNDIMENSION( ITEM )) ;
    PUT ( " abampere " ) ;
  end PUT ;

  procedure PUT ( ITEM : CURRENT_STATAMPERE ) is

  begin
    PUT ( UNDIMENSION( ITEM )) ;
    PUT ( " statampere " ) ;
  end PUT ;

  procedure PUT ( ITEM : VOLTAGE_VOLT ) is

  begin
    PUT ( UNDIMENSION( ITEM )) ;
    PUT ( " volt " ) ;
  end PUT ;

  procedure PUT ( ITEM : VOLTAGE_MILLIVOLT ) is

  begin
    PUT ( UNDIMENSION( ITEM )) ;
    PUT ( " millivolt " ) ;
  end PUT ;

  procedure PUT ( ITEM : VOLTAGE_MICROVOLT ) is

  begin
    PUT ( UNDIMENSION( ITEM )) ;
    PUT ( " microvolt " ) ;
  end PUT ;

  procedure PUT ( ITEM : VOLTAGE_KILOVOLT ) is

  begin
    PUT ( UNDIMENSION( ITEM )) ;
    PUT ( " kilovolt " ) ;
  end PUT ;

  procedure PUT ( ITEM : RESISTANCE_OHM ) is

  begin
    PUT ( UNDIMENSION( ITEM )) ;
    PUT ( " ohm " ) ;
  end PUT ;

  procedure PUT ( ITEM : RESISTANCE_MILLIOHM ) is

  begin
    PUT ( UNDIMENSION( ITEM )) ;
    PUT ( " milliohm " ) ;
  end PUT ;

  procedure PUT ( ITEM : RESISTANCE_KILOHM ) is

  begin
    PUT ( UNDIMENSION( ITEM )) ;
    PUT ( " kilohm " ) ;
  end PUT ;

  procedure PUT ( ITEM : RESISTANCE_MEGOHM ) is

  begin
    PUT ( UNDIMENSION( ITEM )) ;
    PUT ( " megohm " ) ;
  end PUT ;

  procedure PUT ( ITEM : RESISTIVITY_OHM_METER ) is

  begin
    PUT ( UNDIMENSION( ITEM )) ;
    PUT ( " ohm meter " ) ;
  end PUT ;

  procedure PUT ( ITEM : CONDUCTANCE_MHO ) is

  begin
    PUT ( UNDIMENSION( ITEM )) ;
    PUT ( " mho " ) ;
  end PUT ;

  procedure PUT ( ITEM : CONDUCTIVITY_MHO_PER_METER ) is

  begin
    PUT ( UNDIMENSION( ITEM )) ;
    PUT ( " mho per meter " ) ;
  end PUT ;

  procedure PUT ( ITEM : CAPACITANCE_FARAD ) is

  begin
    PUT ( UNDIMENSION( ITEM )) ;
    PUT ( " farad " ) ;
  end PUT ;

  procedure PUT ( ITEM : CAPACITANCE_MICROFARAD ) is

  begin
    PUT ( UNDIMENSION( ITEM )) ;
    PUT ( " microfarad " ) ;
  end PUT ;

  procedure PUT ( ITEM : CAPACITANCE_PICOFARAD ) is

  begin
    PUT ( UNDIMENSION( ITEM )) ;
    PUT ( " picofarad " ) ;
  end PUT ;

  procedure PUT ( ITEM : INDUCTANCE_HENRY ) is

  begin
    PUT ( UNDIMENSION( ITEM )) ;
    PUT ( " henry " ) ;
  end PUT ;

  procedure PUT ( ITEM : INDUCTANCE_MILLIHENRY ) is

  begin
    PUT ( UNDIMENSION( ITEM )) ;
    PUT ( " millihenry " ) ;
  end PUT ;

  procedure PUT ( ITEM : INDUCTANCE_MICROHENRY ) is

  begin
    PUT ( UNDIMENSION( ITEM )) ;
    PUT ( " microhenry " ) ;
  end PUT ;

  procedure PUT ( ITEM : CURRENT_DENSITY_AMPERE_PER_SQUARE_METER ) is

  begin
    PUT ( UNDIMENSION( ITEM )) ;
    PUT ( " ampere per square meter " ) ;
  end PUT ;

  procedure PUT ( ITEM : CHARGE_DENSITY_COULOMB_PER_CUBIC_METER ) is

  begin
    PUT ( UNDIMENSION( ITEM )) ;
    PUT ( " coulomb per cubic meter " ) ;
  end PUT ;

  procedure PUT ( ITEM : MAGNETIC_FLUX_WEBER ) is

  begin
    PUT ( UNDIMENSION( ITEM )) ;
    PUT ( " weber " ) ;
  end PUT ;

  procedure PUT ( ITEM : MAGNETIC_FLUX_DENSITY_TESLA ) is

  begin
    PUT ( UNDIMENSION( ITEM )) ;
    PUT ( " tesla " ) ;
  end PUT ;

  procedure PUT ( ITEM : MAGNETIC_INTENSITY_AMPERE_PER_METER ) is

  begin
    PUT ( UNDIMENSION( ITEM )) ;
    PUT ( " ampere per meter " ) ;
  end PUT ;

  procedure PUT ( ITEM : MAGNETIC_VECTOR_POTENTIAL_WEBER_PER_METER ) is

  begin
    PUT ( UNDIMENSION( ITEM )) ;
    PUT ( " weber per meter " ) ;
  end PUT ;

  procedure PUT ( ITEM : ELECTRIC_FIELD_INTENSITY_VOLT_PER_METER ) is

  begin
    PUT ( UNDIMENSION( ITEM )) ;
    PUT ( " volt per meter " ) ;
  end PUT ;

  procedure PUT ( ITEM : ELECTRIC_DISPLACEMENT_COULOMB_PER_SQUARE_METER ) is

  begin
    PUT ( UNDIMENSION( ITEM )) ;
    PUT ( " coulomb per square meter " ) ;
  end PUT ;

  procedure PUT ( ITEM : PERMEABILITY_HENRY_PER_METER ) is

  begin
    PUT ( UNDIMENSION( ITEM )) ;
    PUT ( " henry per meter " ) ;
  end PUT ;

  procedure PUT ( ITEM : PERMITTIVITY_FARAD_PER_METER ) is

  begin
    PUT ( UNDIMENSION( ITEM )) ;
    PUT ( " farad per meter " ) ;
  end PUT ;

  procedure PUT ( ITEM : FREQUENCY_HERTZ ) is

  begin
    PUT ( UNDIMENSION( ITEM )) ;
    PUT ( " hertz " ) ;
  end PUT ;

  procedure PUT ( ITEM : FREQUENCY_KILOHERTZ ) is

  begin
    PUT ( UNDIMENSION( ITEM )) ;
    PUT ( " kilohertz " ) ;
  end PUT ;

  procedure PUT ( ITEM : FREQUENCY_MEGAHERTZ ) is

  begin
    PUT ( UNDIMENSION( ITEM )) ;
    PUT ( " megahertz " ) ;
  end PUT ;

  procedure PUT ( ITEM : FREQUENCY_GIGAHERTZ ) is

  begin
    PUT ( UNDIMENSION( ITEM )) ;
    PUT ( " gigahertz " ) ;
  end PUT ;

  procedure PUT ( ITEM : ANGULAR_FREQUENCY_RADIAN_PER_SECOND ) is

  begin
    PUT ( UNDIMENSION( ITEM )) ;
    PUT ( " radian per second " ) ;
  end PUT ;

--
end PHYSICAL_UNITS_OUTPUT_ELECTRICAL ;
