-------- SIMTEL20 Ada Software Repository Prologue ------------
--                                                           -*
-- Unit name    : Body Stubber
-- Version      : 2.0
-- Author       : Joseph M. Orost
--              : Concurrent Computer Corporation
--              : 106 Apple St
--              : Tinton Falls, NJ  07724
-- DDN Address  : petsd!joe@RUTGERS.EDU
-- Copyright    :
-- Date created : 15 July 1983
-- Release date :
-- Last update  : 5 May 1987
-- Machine/System Compiled/Run on : Concurrent Computer Corporation C3Ada R00-01
--                                                           -*
---------------------------------------------------------------
--                                                           -*
-- Keywords     : 
----------------:
--
-- Abstract     : This program reads an Ada specification
----------------: and generates a corresponding Body with 
----------------: stubs for all subprograms.
----------------: All of the OS dependencies are contained in
----------------: the OS_DEPENDENCIES package.
----------------:
----------------: Version 1.0:
----------------: This tool was developed as a precursor for 
----------------: the WMCCS Information System (WIS).  An
----------------: executable version of the tool has been 
----------------: demonstrated.  This source code has sub-
----------------: sequently been recompiled but has not under-
----------------: gone extensive testing.
----------------:
----------------: Version 2.0:
----------------: Complete overhaul.  All non-Ansi Ada 
----------------: dependencies removed.  Bugs fixed/
----------------: Enhancements:
----------------:    Task specifications are now stubbed.
----------------:    Pragma INTERFACE now suppresses stubs.
----------------:    OUTPUT_LINE_LENGTH parameter - not
----------------:     exceeded.
----------------:    Output properly indented and aligned.
----------------:    Overwrite of output file now asks
----------------:     permission.
----------------:    Comments and declarations from spec
----------------:     included in stub.
----------------:    Spec is no longer duplicated in output.
----------------:    ID Comment is generated on "begin".
----------------:    Execution-time message now is fully
----------------:     qualified.
----------------:    Exception handler part is now a source
----------------:     parameter.
----------------:    Multiple specs in input file now works.
----------------:    Generic "with procedure" or "with
----------------:     function" now not taken as declaration 
----------------:     to be stubbed.
----------------: In addition, many code speed-ups are
----------------: included.
----------------: 
----------------: Rehosting is performed by modifying the
----------------: package OS_DEPENDENCIES: (file OSDEPxxx.ADA)
----------------:    Select the output line length.
----------------:    Select the indent amount and indent limit.
----------------:    Select the standard suffix for the
----------------:     input/output files.
----------------:    Code ADD_SUFFIX to insert the suffix into
----------------:     the filename.
--                                                           -*
------------------ Revision history ---------------------------
--                                                           -*
-- DATE         VERSION AUTHOR                  HISTORY 
-- 07/15/83     1.0     Steven E. Nameroff      Initial Release
-- 05/05/87     2.0     Joseph M. Orost         Major rewrite
--                                                           -*
------------------ Distribution and Copyright -----------------
--                                                           -*
-- This prologue must be included in all copies of this software.
-- 
-- This software is released to the Ada community.
-- This software is released to the Public Domain (note:
--   software released to the Public Domain is not subject
--   to copyright protection).
-- Restrictions on use or distribution:  NONE
--                                                           -*
----------------- Disclaimer ----------------------------------
--                                                           -*
-- This software and its documentation are provided "AS IS" and
-- without any expressed or implied warranties whatsoever.
--
-- No warranties as to performance, merchantability, or fitness
-- for a particular purpose exist.
--
-- Because of the diversity of conditions and hardware under
-- which this software may be used, no warranty of fitness for
-- a particular purpose is offered.  The user is advised to 
-- test the software thoroughly before relying on it.  The user
-- must assume the entire risk and liability of using this 
-- software.
--
-- In no event shall any person or organization of people be
-- held responsible for any direct, indirect, consequential
-- or inconsequential damages or lost profits.
--                                                          -*
----------------- Known Problems -----------------------------
--
-- The stubber does not handle task declarations with entry
-- families that are specified other than: 
--         (integer_LB .. integer_UB)
-- In this case, the body stub contains ACCEPT statements for
-- all family members IN integer_LB .. integer_UB.
--
-- Entry families specified by 
--         (TYPE_NAME) or 
--         (TYPE_NAME'RANGE) 
-- will cause a legal body to be generated, but only 1 accept
-- statement (for TYPE_NAME'FIRST) is generated.  A warning
-- message is produced.
--
-- Entry families of the form:
--         (Expression .. Expression)
-- causes illegal code produced in the body stub.  A warning
-- message is produced.
--
----------------- END-PROLOGUE -------------------------------

