
-------- SIMTEL20 Ada Software Repository Prologue ------------
--
-- Unit name    : COUNT_OF_ADA_STATEMENTS
-- Version      : 1.0
-- Author       : W. A. Whitaker, WIS JPMO
-- DDN Address  : WWHITAKER@ECLB
-- Copyright    :
-- Date created :  3 MAR 84
-- Release date : 15 JAN 85
-- Last update  :  3 MAR 84
-- Machine/System Compiled/Run on :
--
---------------------------------------------------------------
--
-- Keywords     :  Source analysis, Quantity, Statements
--
----------------:
--
-- Abstract     :
--  This function calculates the "STATEMENTS" of a valid Ada fragment
--  specified by a FILE_NAME string parameter.
--  It need not be a complete compilation unit
--  but it should have closed all open parentheses and string brackets.
--  The number of STATEMENTS of code is returned as an INTEGER.

--  The Ada statement is defined by a semicolon terminator
--  outside of comments, parentheses, or string or character literals.
--  This definition is insensitive to formatting or layout of the source.

--  There are exotic cases for which this will misestimate the count
--  but we have never encountered one in real code.

--  This copy of the function is embedded in a test and driver program.
--  Running the program on its own source file should give
--  The driver has an additional feature of correcting for the common
--  error of leaving out the extension on a file name.
--  The nature of this extension is system dependent and a ".TXT" is used.

--
------------------ Revision history ---------------------------
--
-- DATE         VERSION         AUTHOR          HISTORY
-- 19850115     1.0             W Whitaker      Initial Release
--
------------------ Distribution and Copyright -----------------
--
-- This software is released to the Public Domain (note:
--   software released to the Public Domain is not subject
--   to copyright protection).
--
------------------ Disclaimer ---------------------------------
--
-- This software and its documentation are provided "AS IS" and
-- without any expressed or implied warranties whatsoever.
-- No warranties as to performance, merchantability, or fitness
-- for a particular purpose exist.
--
-- In no event shall any person or organization of people be
-- held responsible for any direct, indirect, consequential
-- or inconsequential damages or lost profits.
--
-------------------END-PROLOGUE--------------------------------
