
-------- SIMTEL20 Ada Software Repository Prologue ------------
--                                                           -*
-- Unit name    : CONSTRUCT and CREATE_CO
-- Version      : 841201
-- Author       : Mitre Corp.
-- DDN Address  : wis_ada at mitre
-- Copyright    :
-- Date created : 10 NOV 84
-- Release date : 15 DEC 84
-- Last update  : 21 JAN 85
-- Machine/System Compiled/Run on : Intellimac 7000M
--               :                   UNIX
--               :                   Telesoft unvalidated
--                                                           -*
---------------------------------------------------------------
--                                                           -*
-- Keywords     :  Automatic Compilation, Compilation Order,
--                 Configuration Management, Dependency Graph
--                 Scan Ada Source for withs and separates
----------------:
--
-- Abstract     :  
--         The function of Construct is to perform the minimal number
--    of system commands to bring a project up to date given that
--    changes to project files have occurred.  If a project is already
--    up to date, Construct will indicate this and no commands will be
--    performed.  Construct can also be used to supply descriptive
--    information in the form of dependency graphs and name lists of
--    project files.
--
--         Create_CO reads a set of Ada source code files and creates
--    a configuration object which describes the dependencies that
--    exist among the files.  The configuration object is formatted so
--    that it may be read by Construct.  In determining dependencies,
--    Create_CO observes the filenaming conventions of the TeleSoft
--    Ada compiler (i.e., filename extensions of .text, .sym, .code)
--    and the compiler's language restriction that specifications and
--    bodies of Ada packages reside in the same file.
----------------:  
--                                                           -*
------------------ Revision history ---------------------------
--                                                           -*
-- DATE      VERSION AUTHOR        HISTORY
-- 12/15/84  841201  Mitre Corp    Initial Release
-- 01/21/85  841201  Mitre Corp    Converted subfile headers
--                                 into Ada comments
--                                                           -*
------------------ Distribution and Copyright -----------------
--                                                           -*
-- This prologue must be included in all copies of this software.
--
-- This software is released to the Public Domain (note:
--   software released to the Public Domain is not subject
--   to copyright protection).
--
-- Restrictions on use or distribution:  Although there are
--      no current plans to provide maintenance for CONSTRUCT
--      or CREATE_CO, we would appreciate your reporting
--      problems and experiences to:
--              
--                wis_ada at mitre (net address)
--
--      or call at:
--
--                (703)  883-7697
--                                                           -*
------------------ Disclaimer ---------------------------------
--                                                           -*
-- This software and its documentation are provided "AS IS" and
-- without any expressed or implied warranties whatsoever.
-- No warranties as to performance, merchantability, or fitness
-- for a particular purpose exist.
--
-- Because of the diversity of conditions and hardware under
-- which this software may be used, no warranty of fitness for
-- a particular purpose is offered.  The user is advised to
-- test the software thoroughly before relying on it.  The user
-- must assume the entire risk and liability of using this
-- software.
--
-- In no event shall any person or organization of people be
-- held responsible for any direct, indirect, consequential
-- or inconsequential damages or lost profits.
--                                                           -*
-------------------END-PROLOGUE--------------------------------

