


-------- SIMTEL20 Ada Software Repository Prologue ------------
--                                                           -*
-- Unit name    : CREATE_TB
-- Version      : 850121
-- Author       : Mitre Corp.
-- DDN Address  : wis_ada at mitre
-- Copyright    :
-- Date created : 21 JAN 85
-- Release date : 26 JAN 85
-- Last update  : 26 JAN 85
-- Machine/System Compiled/Run on : Intellimac 7000M
--               :                   UNIX
--               :                   Telesoft unvalidated
--                                                           -*
---------------------------------------------------------------
--                                                           -*
-- Keywords     :  Table builder, Text formatter
--
----------------:
--
-- Abstract     :  
--     CREATE_TB scans text files and creates a table by selecting
-- specified line entries.  The text files are assumed to contain
-- standardized entries which are repeated in each file.  CREATE_TB
-- extracts a subset of these entries compressing their text into
-- a specified column width for printing in a tabular form.  The
-- entries to be extracted and the width of each column may be
-- specified by the user for each table.  CREATE_TB will scan a group
-- of files identified by a UNIX file pattern(including *, ?, or
-- selectors [aeiou]) and it also recognizes PAGE headers of the form:
--
--              ::::::::::               --::::::::::
--              FILENAME       or        --FILENAME
--              ::::::::::               --::::::::::
--
-- as file separators.
----------------:  
--                                                           -*
------------------ Revision history ---------------------------
--                                                           -*
-- DATE         VERSION	AUTHOR       HISTORY
-- 12/15/84	1.0	Mitre Corp   Initial Release
-- 01/21/85     850121  Mitre Corp   Mod to accept --::::::: headers
--                                   Mod to correctly process blank
--                                       lines when building heading
--                                   Mod to stop on subfile header
--                                       when building heading
--                                   Moved PUT_DYNAMIC procedure
--                                       from STR_PACK to CREATE_TB
--                                   Added comments to STR_PACK and
--                                       deleted several string 
--                                       procedures
--                                   Converted subfile headers to
--                                       Ada comments  --:::::::::
--                                                           -*
------------------ Distribution and Copyright -----------------
--                                                           -*
-- This prologue must be included in all copies of this software.
--
-- This software is released to the Public Domain (note:
--   software released to the Public Domain is not subject
--   to copyright protection).
--
-- Restrictions on use or distribution:  Although there are
--      no current plans to provide maintenance for CREATE_TB,
--      we would appreciate your reporting problems and
--      experiences to:
--              
--                wis_ada at mitre (net address)
--
--      or call at:
--
--                (703)  883-7697
--                                                           -*
------------------ Disclaimer ---------------------------------
--                                                           -*
-- This software and its documentation are provided "AS IS" and
-- without any expressed or implied warranties whatsoever.
-- No warranties as to performance, merchantability, or fitness
-- for a particular purpose exist.
--
-- Because of the diversity of conditions and hardware under
-- which this software may be used, no warranty of fitness for
-- a particular purpose is offered.  The user is advised to
-- test the software thoroughly before relying on it.  The user
-- must assume the entire risk and liability of using this
-- software.
--
-- In no event shall any person or organization of people be
-- held responsible for any direct, indirect, consequential
-- or inconsequential damages or lost profits.
--                                                           -*
-------------------END-PROLOGUE--------------------------------


