
-------- SIMTEL20 Ada Software Repository Prologue ------------
--                                                           -*
-- Unit name    : FILE_CHECKER
-- Version      : 1.3
-- Author       : Richard Conn
--              : TI Ada Technology Branch
--              : Box 801, MS 8007
--              : McKinney, TX  75069
-- DDN Address  : RCONN at SIMTEL20
-- Copyright    : (c) 1985 Richard Conn
-- Date created : 15 Feb 85
-- Release date : 15 Feb 85
-- Last update  :  2 Dec 85
-- Machine/System Compiled/Run on : DG MV 10000, ROLM ADE
--                                  DEC VAX 11/780, DEC Ada
--                                                           -*
---------------------------------------------------------------
--                                                           -*
-- Keywords     :
----------------: Ada Statements, Lines of Code, LOC, Checksum
--
-- Abstract     :
----------------: FILE_CHECKER uses CAS3 to count the number
-- of Ada statements (terminated by semicolons), the number of
-- lines of code, and a checksum of the non-space (excludes tabs,
-- CR, LF, FF, HT, and spaces) characters in a group of files.
--
-- FILE_CHECKER asks for one file name after another; the user
-- terminates his input by striking RETURN to the file name prompt.
-- FILE_CHECKER then gives a summary report of this data on all
-- files listed.  Include files may be specified along with
-- other file names.
--
-- Ada components used by FILE_CHECKER include GENERIC_LIST and CAS3.
-- CHARACTER_SET is used by CAS3.
-- All are in the Ada Repository in the COMPONENTS subdirectory.
--                                                           -*
------------------ Revision history ---------------------------
--                                                           -*
-- DATE         VERSION AUTHOR                  HISTORY
-- 2/15/85      1.0     Richard Conn            Initial Release
-- 4/9/85       1.1     Richard Conn            Add Include Files, CAS3
-- 9/25/85      1.2     Richard Conn            Add Output File, Misc
-- 12/2/85      1.3     Richard Conn            Add Count Summary
--                                                           -*
------------------ Distribution and Copyright -----------------
--                                                           -*
-- This prologue must be included in all copies of this software.
--
-- This software is copyright by the author.
--
-- This software is released to the Ada community.
-- This software is released to the Public Domain (note:
--   software released to the Public Domain is not subject
--   to copyright protection).
-- Restrictions on use or distribution:  NONE
--                                                           -*
------------------ Disclaimer ---------------------------------
--                                                           -*
-- This software and its documentation are provided "AS IS" and
-- without any expressed or implied warranties whatsoever.
-- No warranties as to performance, merchantability, or fitness
-- for a particular purpose exist.
--
-- Because of the diversity of conditions and hardware under
-- which this software may be used, no warranty of fitness for
-- a particular purpose is offered.  The user is advised to
-- test the software thoroughly before relying on it.  The user
-- must assume the entire risk and liability of using this
-- software.
--
-- In no event shall any person or organization of people be
-- held responsible for any direct, indirect, consequential
-- or inconsequential damages or lost profits.
--                                                           -*
-------------------END-PROLOGUE--------------------------------
